local app = select(2, ...);
local SetsFrame;

local ModelFrame;
local setStats = { numberSets = 0, numberCollected = 0 };
local alreadyFilled = false;
local maxGarbage = 4;

--displayFemale = 1
local displayBools = {displayFemale = 1};--{ displayOtherFaction = false, displayOnlyMyClass = false };
local defaultSex;
local currentRaceID = 0;
local ExpansionCount = 9;

local BaseSets = {};
local BaseSetsPvPFlag = {};
local BaseSetsData = {};
local BaseList = {};
local VariantSets = {};
local VariantSetsIDs = {};

local factionNames = { playerFaction = "", opposingFaction = "" };

local ClassName;
local ClassIndex = nil;
local ClassMaskMap = {
    [1] = {1, 2, 32, 35, 0}, -- Plate Wearer
    [2] = {1, 2, 32, 35, 0}, -- Plate Wearer
    [3] = {4, 64, 68, 0},    -- Mail Wearer
    [4] = {8, 512, 1024, 2048, 3592, 0}, -- Leather Wearer
    [5] = {16, 128, 256, 400, 0}, -- Cloth Wearer
    [6] = {1, 2, 32, 35, 0}, -- Plate Wearer
    [7] = {4, 64, 68, 0},    -- Mail Wearer
    [8] = {16, 128, 256, 400, 0}, -- Cloth Wearer
    [9] = {16, 128, 256, 400, 0}, -- Cloth Wearer
    [10] = {8, 512, 1024, 2048, 3592, 0}, -- Leather Wearer
    [11] = {8, 512, 1024, 2048, 3592, 0}, -- Leather Wearer
    [12] = {8, 512, 1024, 2048, 3592, 0}, -- Leather Wearer
}
local ClassNameMask = {
    [1] = "Warrior",
    [2] = "Paladin",
    [4] = "Hunter",
    [8] = "Rogue",
    [16] = "Priest",
    [32] = "Death Knight",
    [64] = "Shaman",
    [128] = "Mage",
    [256] = "Warlock",
    [512]  = "Monk",
    [1024] = "Druid",
    [2048] = "Demon Hunter",
}
local ClassNameLookupMask = {
    [1] = "WARRIOR",
    [2] = "PALADIN",
    [4] = "HUNTER",
    [8] = "ROGUE",
    [16] = "PRIEST",
    [32] = "DEATHKNIGHT",
    [64] = "SHAMAN",
    [128] = "MAGE",
    [256] = "WARLOCK",
    [512] = "MONK",
    [1024] = "DRUID",
    [2048] = "DEMONHUNTER",
}
local ClassToMask = {
    [1] = 1,
    [2] = 2,
    [3] = 4,
    [4] = 8,
    [5] = 16,
    [6] = 32,
    [7] = 64,
    [8] = 128,
    [9] = 256,
    [10] = 512,
    [11] = 1024,
    [12] = 2048,
}
local ClassArmorType = {
    [1]  = 4, --[1]  = 1, --[1] =    
    [2]  = 4, --[2]  = 1, --[2] =    
    [3]  = 3, --[3]  = 2, --[4] =    
    [4]  = 2, --[4]  = 3, --[8] =    
    [5]  = 1, --[5]  = 4, --[16] =   
    [6]  = 4, --[6]  = 1, --[32] =   
    [7]  = 3, --[7]  = 2, --[64] =   
    [8]  = 1, --[8]  = 4, --[128] =  
    [9]  = 1, --[9]  = 4, --[256] =  
    [10] = 2, --[10] = 3, --[512] =  
    [11] = 2, --[11] = 3, --[1024] = 
    [12] = 2, --[12] = 3, --[2048] = 
}
local ClassArmorMask = {
    [1]  = {0, 1, 35},
    [2]  = {0, 2, 35},
    [3]  = {0, 4, 68},
    [4]  = {0, 8, 3592},
    [5]  = {0, 16, 400},
    [6]  = {0, 32, 35},
    [7]  = {0, 64, 68},
    [8]  = {0, 128, 400},
    [9]  = {0, 256, 400},
    [10] = {0, 512, 3592},
    [11] = {0, 1024, 3592},
    [12] = {0, 2048, 3592},
}
local ArmorTypeRadio = {};
local pvpDescriptions = {
    ["Honor"] = true,
    ["Gladiator"] = true,
    ["Elite"] = true,
    ["Warfront"] = true,
    ["Aspirant"] = true,
    ["Combatant"] = true,
}
local raceIDs = {
    1,2,3,4,5,6,7,8,9,
    10,11,22,24,27,28,29,30,
    31,32,34,36
}
local raceList = {};
local heritageSets = {
    [1522] = 28, --Highmountain
    [1523] = 27, --Nightborne
    [1524] = 29, --Void Elves
    [1525] = 30, --Lightforged Draenei
    [1679] = 34, --Dark Iron Dwarves
    [1680] = 36, --Warsong (Mag'har)
    [1681] = 36, --BlackRock (Mag'har)
    [1682] = 36, --Frostwolves (Mag'har)
    [1741] = 32, --Kul Tirans
    [1742] = 31, --Zandalari
    [1803] = 3, --Dwarves
    [1804] = 10, --Blood Elves
    [1828] = 7, --Gnome
    [1829] = 6, --Tauren
    [1980] = 37, --Mechagnome
    [1981] = 35, --Vulpera
    [1976] = 22, --Worgen
    [1977] = 9, --Goblin
}

local ScrollFrameUpdate;
local ExS_ScrollFrame = nil;
local _FavoriteDropDown = nil;
local _ButtonHeight = nil;
local _ButtonsInFrame = nil;
local ArmorTypeRadioIsChecked = { false, false, false, false };

local BASE_SET_BUTTON_HEIGHT = 46;
local VARIANT_SET_BUTTON_HEIGHT = 20;
local SET_PROGRESS_BAR_MAX_WIDTH = 204;

local colors = {  IN_PROGRESS_FONT_COLOR = CreateColor(0.251, 0.753, 0.251),
                  IN_PROGRESS_FONT_COLOR_CODE = "|cff40c040",
                  LOW_PROGRESS_COLOR = CreateColor(0.8, 0.2, 0.08)
                };

local func_ScrollToOffset;

local ExpandedID = 1000000;

local ExpandedCallbacks = {};
app.ExpandedCallbacks = ExpandedCallbacks;

-----------------------------------------------------------------------------------------------------------
  --Gettors--
-----------------------------------------------------------------------------------------------------------

local function SplitModedID(id)
  local _,_,div, mod = string.find(id,"(%d+)m(%d+)");
  if div == nil then
    return id;
  end
  return tonumber(div), tonumber(mod);
end

--Get the set data by its ID.
local function GetSetByID(SetID)
  if (BaseSets[SetID] ~= nil) then
    return BaseSets[SetID];
  end
  
  if (VariantSetsIDs[SetID] ~= nil) then
    if (VariantSets[VariantSetsIDs[SetID]] ~= nil) then
      return VariantSets[VariantSetsIDs[SetID]];
    end
  end
  
	return nil;
end

--Get the ID of this set's Base Set.
local function GetBaseSetID(SetID)
	--if this is a base set, return the id
  if (BaseSets[SetID] ~= nil) then
    return SetID;
  end
  --else, get the variable set and return its baseSetID
  local varSet = VariantSets[VariantSetsIDs[SetID]];
  return varSet.baseSetID;
end

--Returns a string with the name of the class colored with its class color.
local function GetColoredClassNameString(classMask)
  if (ClassNameMask[classMask] ~= nil) then
    local classColorRet = C_ClassColor.GetClassColor(ClassNameLookupMask[classMask]);
    local classColor = string.format("%02X%02X%02X ",classColorRet.r*256,classColorRet.g*256,classColorRet.b*256);
    return "|cFF"..classColor..ClassNameMask[classMask].."|r";
  end
  return "";
end

--Returns a string colored based on the required faction.
local function GetFactionColoredString(stringToColor, faction)
  if (faction == "Horde") then
    return "|cFF8C1616"..stringToColor.."|r";
  else
    return "|cFF162C57"..stringToColor.."|r";
  end
end

--Returns a string that is a colorized version of the given string.
--If it fails to color, it will return the given string.
local function ColorStringByClass(toColor,classMask)
  if (ClassNameMask[classMask] ~= nil) then
    local classColorRet = C_ClassColor.GetClassColor(ClassNameLookupMask[classMask]);
    local classColor = string.format("%02X%02X%02X ",classColorRet.r*256,classColorRet.g*256,classColorRet.b*256);
    return "|cFF"..classColor..toColor.."|r";
  end
  return toColor;
end

--Returns a string that is a colorized version of the given string.
--Inputs: String, Red value, Green value, Blue value
local function ColorString(toColor,r,g,b)
  local color = string.format("%02X%02X%02X ",r*256,g*256,b*256);
  return "|cFF"..color..toColor.."|r";
end

--Find if Base Set is New
local function IsBaseSetNew(baseSetID)
	local baseSetData = SetsFrame.GetBaseSetData(baseSetID);
	if ( not baseSetData.newStatus ) then
		local newStatus = C_TransmogSets.SetHasNewSources(baseSetID);
		if ( not newStatus ) then
			-- check variants
			local variantSets = SetsFrame.GetVariantSets(baseSetID);
			for i, variantSet in ipairs(variantSets) do
				if(variantSet.setID ~= nil) then
					if ( C_TransmogSets.SetHasNewSources(variantSet.setID) ) then
						newStatus = true;
						break;
					end
				end
			end
		end
		baseSetData.newStatus = newStatus;
	end
	return baseSetData.newStatus;
end

--Reset the new status on the base set.
local function ResetBaseSetNewStatus(baseSetID)
	local baseSetData = SetsFrame.GetBaseSetData(baseSetID);
  local isNew = false;
  
  if C_TransmogSets.SetHasNewSources(baseSetID) then
    isNew = true;
  else
    local varSets = SetsFrame.GetVariantSets(baseSetID);
    for i = 1, #varSets do
      if C_TransmogSets.SetHasNewSources(varSets[i].setID) then
        isNew = true;
        break;
      end
    end
  end
	
	baseSetData.newStatus = isNew;
  return isNew;
end

--Get the default set to be displayed when a set is opened.
local function GetDefaultSetIDForBaseSet(setID)
  local baseSetID = setID;
  if type(baseSetID) ~= "number" then
    baseSetID = baseSetID.selectedSetID;
  end
  baseSetID = GetBaseSetID(baseSetID);
  
	if ( IsBaseSetNew(baseSetID) ) then
		if ( C_TransmogSets.SetHasNewSources(baseSetID) ) then
			return baseSetID;
		else
			local variantSets = SetsFrame.GetVariantSets(baseSetID);
			for i, variantSet in ipairs(variantSets) do
				if ( C_TransmogSets.SetHasNewSources(variantSet.setID) ) then
					return variantSet.setID;
				end
			end
		end
	end

	local baseSet = BaseSets[baseSetID];
	if ( baseSet and baseSet.favoriteSetID ) then
		return baseSet.favoriteSetID;
	end
	-- pick the one with most collected
  -- In ties the higher difficulty wins ties, unless the tie is across classes
  -- In which case the first class wins (which puts the player's current class in favor)
	local highestCount = 0;
	local highestCountSetID = baseSetID;
  local highestCountClassMask = 0;
	local variantSets = SetsFrame.GetVariantSets(baseSetID, true);
	for i = 1, #variantSets do
		local variantSetID = variantSets[i].setID
		local numCollected = SetsFrame.GetSetSourceCounts(variantSetID);
		if (numCollected > highestCount) or (numCollected == highestCount and variantSets[i].classMask == highestCountClassMask) then
			highestCount = numCollected;
			highestCountSetID = variantSetID;
      highestCountClassMask = variantSets[i].classMask;
		end
	end
	return highestCountSetID;
end

local function GetBaseSets()
	if ( not alreadyFilled ) then
    InitializeSets();
	end
	return BaseList;
end

--Gets the Variant Sets for the specified baseSetID.
--Gets them from the VarSets map.
local function GetVariantSets(baseSetID, sort)
	local variantSet = VariantSets[baseSetID];
  local variantSets = {};
  local i = 0;
  if BaseSets[baseSetID] ~= nil then
    table.insert(variantSets, BaseSets[baseSetID]);
  end
  --while ( variantSet ~= nil and variantSet.baseSetID == baseSetID ) do
  while ( variantSet ~= nil ) do
    if (variantSet.baseSetID == baseSetID) then
      table.insert(variantSets, variantSet);
    end
    i = i + 1;
    variantSet = VariantSets[baseSetID + i];
  end
  
  for key,set in pairs(variantSets) do
    if (set == nil) then
      table.remove(key);
    end
  end
  
  if sort == true then
    local comparison = function (set1, set2)
      if ( set1.requiredFaction ~= set2.requiredFaction) then
        if (set1.requiredFaction == factionNames.playerFaction) then
          return true;
        elseif (set2.requiredFaction == factionNames.playerFaction) then
          return false;
        elseif (set1.requiredFaction == nil) then
          return true;
        else
          return false;
        end
      end
      if set1.classMask ~= set2.classMask then
        if ClassNameMask[set1.classMask] == nil then return true;  end
        if ClassNameMask[set2.classMask] == nil then return false; end
        if set1.classMask == ClassToMask[ClassIndex] then return true; end
        if set2.classMask == ClassToMask[ClassIndex] then return false; end
        return set1.classMask < set2.classMask;
      end
      return set1.uiOrder < set2.uiOrder;
    end
    table.sort(variantSets, comparison);
  end
  
  return variantSets;
end

--Get the data for the items in the set.
local function GetSetSourceData(setID, givenSources, quick)
	if ( not SetsFrame.sourceData ) then
		SetsFrame.sourceData = { };
	end
        --if quick == true then print(tostring(quick)) end
  
	local sourceData = SetsFrame.sourceData[setID];
	if ( not sourceData or C_TransmogSets.SetHasNewSources(setID)) then --need to check new for expanded sets.
		local sources;
    if givenSources ~= nil then
      sources = givenSources;
    else
      sources = SetsFrame.GetSetSources(setID);
    end
    
    local numCollected = 0;
		local numTotal = 0;

		for sourceID,collected in pairs(sources) do
      local sourceInfo = C_TransmogCollection.GetSourceInfo(sourceID);
      if sourceInfo then
        local appearanceID = sourceInfo.visualID;
        
        local thisCollected = false;
        if sourceInfo.isCollected then
          numCollected = numCollected + 1;
          thisCollected = true;
        elseif appearanceID then
          local appSources = C_TransmogCollection.GetAllAppearanceSources(appearanceID);
          
          --local sourceInfos = C_TransmogCollection.GetAppearanceInfoBySource(SplitModedID(sourceID));
          
          for _,sourceID2 in pairs(appSources) do
            --if thisCollected then break; end
            
            local sourceInfos = C_TransmogCollection.GetSourceInfo(sourceID2);
            if sourceInfos ~= nil then
              if sourceInfos.isCollected then
                numCollected = numCollected + 1;
                thisCollected = true;
                break;
              end
            end
          end
        end
        if not thisCollected and quick then return nil; end
        numTotal = numTotal + 1;
      end
		end
		sourceData = { numCollected = numCollected, numTotal = numTotal, sources = sources };
		SetsFrame.sourceData[setID] = sourceData;
	end
	return sourceData;
end

--Get the number of sets and the number of completed sets
local function CalculateCount()
	setStats.numberSets = 0;
	setStats.numberCollected = 0;
  
  if(not alreadyFilled) then
    SetsFrame.InitializeSets();
  end
  
    -- look through the base sets
	for _, baseSet in pairs(BaseSets) do
    --print("quick setting")
    local quickSet = GetSetSourceData(baseSet.setID, {}, true);
    setStats.numberSets = setStats.numberSets + 1;
    if quickSet and quickSet.numCollected == quickSet.numTotal then setStats.numberCollected = setStats.numberCollected + 1; end
		--local numCollected, numTotal = SetsFrame.GetSetSourceCounts(baseSet.setID);
    --
		--if numTotal > 0 then
		--	setStats.numberSets = setStats.numberSets + 1;
		--	if numCollected == numTotal then
		--		setStats.numberCollected = setStats.numberCollected + 1;
		--	end
		--end
	end
  
    -- look through all the variantSets
	for _, varSet in pairs(VariantSets) do
    local quickSet = GetSetSourceData(varSet.setID, nil, true);
    setStats.numberSets = setStats.numberSets + 1;
    if quickSet and quickSet.numCollected == quickSet.numTotal then setStats.numberCollected = setStats.numberCollected + 1; end
		--local numCollected, numTotal = SetsFrame.GetSetSourceCounts(varSet.setID);
    --
		--if numTotal > 0 then
		--	setStats.numberSets = setStats.numberSets + 1;
		--	if numCollected == numTotal then
		--		setStats.numberCollected = setStats.numberCollected + 1;
		--	end
		--end
	end
end

--Get the Number collected and total number of items in the set.
local function GetSetSourceCounts(setID)
	local sourceData = GetSetSourceData(setID);
	return sourceData.numCollected, sourceData.numTotal;
end

--Get the data for the selected set (used for left list).
local function GetBaseSetData(setID)
  local baseSetID = GetBaseSetID(setID);
  local variantSets = GetVariantSets(baseSetID);
  
  local hasNew = C_TransmogSets.SetHasNewSources(baseSetID);
  if not hasNew then
    for i = 1, #variantSets do
      if C_TransmogSets.SetHasNewSources(variantSets[i].setID) then
        hasNew = true;
        break;
      end
    end
  end
  
	if ( not BaseSetsData[setID] or hasNew) then
		--local baseSetID = GetBaseSetID(setID);
    
		local topCollected, topTotal = GetSetSourceCounts(baseSetID);
    local numSets = 0;
    local numFinishedSets = 0;
      
		--local variantSets = GetVariantSets(baseSetID);
		for i = 1, #variantSets do
			local numCollected, numTotal = GetSetSourceCounts(variantSets[i].setID);
      
      numSets = numSets + 1;
      if (numCollected == numTotal) then
        numFinishedSets = numFinishedSets + 1;
      end
      
			if ( numCollected > topCollected ) then
				topCollected = numCollected;
				topTotal = numTotal;
			end
		end
    
		local setInfo = { topCollected = topCollected, topTotal = topTotal, completed = (topCollected == topTotal), numSets = numSets, numFinishedSets = numFinishedSets, allCompleted = (numSets == numFinishedSets), isPvP = BaseSetsPvPFlag[baseSetID] };
		BaseSetsData[setID] = setInfo;
	end
	return BaseSetsData[setID];
end

CreateFrame( "GameTooltip", "ExS_GameTooltip", nil, "GameTooltipTemplate" );
ExS_GameTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" );
-- Allow tooltip SetX() methods to dynamically add new lines based on these
ExS_GameTooltip:AddFontStrings(
    ExS_GameTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
    ExS_GameTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) );
    
--Helper function. Makes an invisible tooltip for the item and parses it to see if it has 
--red error text related to class requirements.
local function IsForClass(itemLink)
  ExS_GameTooltip:ClearLines();
  ExS_GameTooltip:SetHyperlink(itemLink);
  
  for i = 1,ExS_GameTooltip:NumLines() do
    local text = _G["ExS_GameTooltipTextLeft"..i];
    
    if text and text:GetText() then
      local r,g,b = text:GetTextColor();
      if math.floor(r*256) == 255 and math.floor(g*256) == 32 and math.floor(b*256) == 32 then
        if string.find(text:GetText(), "Classes:") then
          return false;
        end
      end
    end
  end
  return true;
end

--Get the items in the set, sorted.
local function GetSortedSetSources(setID)
	local returnTable = { };
 
  --local sourceData = GetSetSourceData(setID);
  local sources = SetsFrame.GetSetSources(setID);
  --for sourceID, collected in pairs(sourceData.sources) do
  for sourceID,_ in pairs(sources) do
    --local div,mod = SplitModedID(sourceID)
    --if mod ~= nil then div = div + (mod/10); end
    local sourceInfo = C_TransmogCollection.GetSourceInfo(sourceID);
    local sortOrder = EJ_GetInvTypeSortOrder(sourceInfo.invType);
    local appearanceID = sourceInfo.visualID;
    
    local itemArmorType = select(7,GetItemInfoInstant(sourceInfo.itemID));
    local isPlayerArmorWeight = (sourceInfo.invType == 17) or (itemArmorType == 0) or (itemArmorType == 5) or (ClassArmorType[select(3,UnitClass('player'))] == itemArmorType);
    
    if not appearanceID then
      appearanceID = sourceInfo.visualID;
    end
    
    local appSources = C_TransmogCollection.GetAllAppearanceSources(appearanceID);
    
    --Get Sources from the other function. Everything this function returns should be in the above function
    --(since it is supposed to be AllSources), but apparently it isn't everything and this tries to pick up the slack.
    local appSources2 = C_TransmogCollection.GetAppearanceSources(appearanceID);
    if (appSources2 and appSources) then
      for i = 1, #appSources2 do
        local addToAppSources = true;
        for j = 1, #appSources do
          if appSources2[i].sourceID == appSources[j] then
            addToAppSources = false;
            break;
          end
        end
        if addToAppSources then
          table.insert(appSources, appSources2[i].sourceID);
          --print("Added a source");
        end
      end
    elseif appSources2 and not appSources then --I don't think this will ever happen, but just a safety check.
      appSources = appSources2;
    end
    
      
    local isCollectedAccount = false;
    local canCharCollectIt = false;
    local isCollectedChar = false;
    
    
    if appSources then
      for _,sourceID2 in pairs(appSources) do
        local sources = C_TransmogCollection.GetSourceInfo(sourceID2);
        
        local link = select(6, C_TransmogCollection.GetAppearanceSourceInfo(sources.sourceID));
        if sources.isCollected then
          isCollectedAccount = true;
        end
        local isForClass = IsForClass(link);
        
        if isPlayerArmorWeight and not canCharCollectIt and isForClass then
          canCharCollectIt = true;
        end
        if isPlayerArmorWeight and not isCollectedChar and isForClass and sources.isCollected then
          isCollectedChar = true;
        end
        
        if isCollectedAccount and canCharCollectIt and isCollectedChar then
          break;
        end
      end
    end
    
    tinsert(returnTable, { sourceID = sourceID, collected = isCollectedAccount, sortOrder = sortOrder, itemID = sourceInfo.itemID,
                           invType = sourceInfo.invType, isCollectedChar = isCollectedChar, canCharCollectIt = canCharCollectIt });
  end

	local comparison = function(entry1, entry2)
		if ( entry1.sortOrder == entry2.sortOrder ) then
			return entry1.itemID < entry2.itemID;
		else
			return entry1.sortOrder < entry2.sortOrder;
		end
	end
	table.sort(returnTable, comparison);
	return returnTable;
end

--Get Table of Sources for a given slot (helmet, shoulder, etc.). Used for tooltips.
local function GetSetSourcesForSlot(setID, slot)
  --local blizzSources = C_TransmogSets.GetSourcesForSlot(setID, slot);
  --
  --  if slot == 8 then
  --    if blizzSources then
  --      print("blizzSources with "..#blizzSources.." sources");
  --    else
  --      print("blizzSources nil");
  --    end
  --  end
  --if blizzSources ~= nil then
  --  return blizzSources;
  --end
  
  if slot == 16 then slot = 13; end
  --Because for some reasons the cloaks all have the wrong slot.
  if slot == 15 then slot = 16; end
  local sources = GetSortedSetSources(setID);
  
  for _,source in pairs(sources) do
    local sourceID = source.sourceID;
    local sourceInfo = C_TransmogCollection.GetSourceInfo(sourceID);
    local appearanceID = sourceInfo.visualID;
    
    local sourceInvType = sourceInfo.invType - 1;
    if (sourceInvType == 20) then sourceInvType = 5; end
    if (sourceInvType == 14) or (sourceInvType == 15) or (sourceInvType == 17) or (sourceInvType == 21) or (sourceInvType == 22) then sourceInvType = 13; end
    
    
    if (slot == sourceInvType) then
      local appSourcesIDs = C_TransmogCollection.GetAllAppearanceSources(sourceInfo.visualID);
      
      local appSources = {};
      for i=1,#appSourcesIDs do
        table.insert(appSources, C_TransmogCollection.GetSourceInfo(appSourcesIDs[i]));
      end
      
      if #appSources == 0 then
        table.insert(appSources, sourceInfo);
      end
      
      return appSources;
    end
  end
end

--Get icon for the set.
local function GetIconForSet(setID)
	local sourceData = GetSetSourceData(setID);
	if ( not sourceData.icon ) then
		local sortedSources = GetSortedSetSources(setID);
		if ( sortedSources[1] ) then
			local _, _, _, _, icon = GetItemInfoInstant(sortedSources[1].itemID);
			sourceData.icon = icon;
		else
			sourceData.icon = QUESTION_MARK_ICON;
		end
	end
	return sourceData.icon;
end

-----------------Working on this
local function GetNewSources(setID)
--issue
  local valid = C_TransmogSets.SetHasNewSources(setID);
  if valid then
    C_TransmogSets.GetSetNewSources(setID);
    C_TransmogSets.SetHasNewSourcesForSlot(setID, transmogSlot)
  else
  
  end
end

local function GetSetSources(setID, givenSet)
  local set;
  if givenSet ~= nil then
    set = givenSet;
  else
    set = GetSetByID(setID);
  end
  
  --local sources = nil;
  --if set ~= nil then
  --  sources = set.sources;
  --end
  --if sources == nil then
  if set.sources == nil then
    set.sources = C_TransmogSets.GetSetSources(setID);
  end
  return set.sources;
end

local function GetSetContainingSourceID(sourceID)
print(sourceID);
  local visualID = C_TransmogCollection.GetSourceInfo(sourceID).visualID;
  
  for i = 1, #BaseList do
    --if BaseList[i].visualIDs ~= nil then
    --  for visualID2,setID in pairs(#BaseList[i].visualIDs) do
    --    if visualID == visualID2 then
    --      return setID;
    --    end
    --  end
    --else
      local variantSets = GetVariantSets(BaseList[i].setID, false);
    --  local returnID = nil;
    --  local visualIDs = {};
    
      for id,set in pairs(variantSets) do
        if set.sources == nil then
          GetSetSources(set.setID);
        end
        for sourceID2,_ in pairs(set.sources) do
          local visID = C_TransmogCollection.GetSourceInfo(SplitModedID(sourceID2)).visualID;
    --      visualIDs[visID] = set.setID;
          if visualID == visID then
    --        returnID = set.setID;
            return set.setID;
          end
        end
      end
    --  return returnID;
    --end
  end
end

-----------------------------------------------------------------------------------------------------------
  --Events--
-----------------------------------------------------------------------------------------------------------

local function OnShow()
	--WardrobeCollectionFrame.SetsCollectionFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED");
	WardrobeCollectionFrame.SetsCollectionFrame:RegisterEvent("TRANSMOG_COLLECTION_ITEM_UPDATE");
	WardrobeCollectionFrame.SetsCollectionFrame:RegisterEvent("TRANSMOG_COLLECTION_UPDATED");
	-- select the first set if not init
  if(not alreadyFilled) then
    SetsFrame.InitializeSets();
  end
  
  
  
  
	if ( not WardrobeCollectionFrame.SetsCollectionFrame.init ) then
		WardrobeCollectionFrame.SetsCollectionFrame.init = true;
		if ( BaseList and BaseList[1] ) then
			WardrobeCollectionFrame.SetsCollectionFrame:SelectSet(WardrobeCollectionFrame.SetsCollectionFrame:GetDefaultSetIDForBaseSet(BaseList[1].setID));
		end
	else
		WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
	end

	local latestSource = SetsFrame.LatestSource;
  if latestSource == nil then
    latestSource = C_TransmogSets.GetLatestSource();
  end
	if ( latestSource ~= NO_TRANSMOG_SOURCE_ID and latestSource ~= 0) then
		local setID = GetSetContainingSourceID(latestSource);
		if ( setID ) then
			WardrobeCollectionFrame.SetsCollectionFrame:SelectSet(setID);
			SetsFrame.ScrollToSet(setID);
		end
		WardrobeCollectionFrame.SetsCollectionFrame:ClearLatestSource();
    SetsFrame.LatestSource = nil;
	end

	WardrobeCollectionFrame.progressBar:Show();
	WardrobeCollectionFrame.SetsCollectionFrame:UpdateProgressBar();
	WardrobeCollectionFrame.SetsCollectionFrame:RefreshCameras();

  --First if is for BfA system, elseif is the SL version. Remove front half with pre-patch.
  if (WardrobeCollectionFrame.SetsCollectionFrame:GetParent().SetsTabHelpBox) then
    if (WardrobeCollectionFrame.SetsCollectionFrame:GetParent().SetsTabHelpBox:IsShown()) then
      WardrobeCollectionFrame.SetsCollectionFrame:GetParent().SetsTabHelpBox:Hide()
      SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_SETS_TAB, true);
    end
  elseif HelpTip:IsShowing(WardrobeCollectionFrame, TRANSMOG_SETS_TAB_TUTORIAL) then
		HelpTip:Hide(WardrobeCollectionFrame, TRANSMOG_SETS_TAB_TUTORIAL);
    SetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_TRANSMOG_SETS_TAB, true);
  end
  
  if #BaseList == 0 then
    SetsFrame.DisplaySet();
  end
end

local function OnHide()
	--WardrobeCollectionFrame.SetsCollectionFrame:UnregisterEvent("GET_ITEM_INFO_RECEIVED");
	WardrobeCollectionFrame.SetsCollectionFrame:UnregisterEvent("TRANSMOG_COLLECTION_ITEM_UPDATE");
	WardrobeCollectionFrame.SetsCollectionFrame:UnregisterEvent("TRANSMOG_COLLECTION_UPDATED");
	WardrobeCollectionFrame_ClearSearch(LE_TRANSMOG_SEARCH_TYPE_BASE_SETS);
end

--Callback for Updating Item Frames. Used to limit refreshing/multiple false refreshes as loading in a set
--could cause the update event to trigger up to 9 times.
local alreadyADelayedItemUpdateCallback = false;
local function UpdateItemCallback()
  for itemFrame in WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:EnumerateActive() do
    SetsFrame.HandleItemFrames(itemFrame, false);
  end
  if WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID() ~= nil then --Can happen if you set filters in a way to make an empty list.
    SetsFrame.DisplaySet();
  end
  
  alreadyADelayedItemUpdateCallback = false;
end


local function OnEvent(self, event, ...)
	--if ( event == "GET_ITEM_INFO_RECEIVED" ) then
		--local itemID = ...;
		--for itemFrame in WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:EnumerateActive() do
		--	if ( itemFrame.itemID == itemID ) then
		--		WardrobeCollectionFrame.SetsCollectionFrame:SetItemFrameQuality(itemFrame);
		--		break;
		--	end
		--end
	if ( event == "TRANSMOG_COLLECTION_ITEM_UPDATE" ) then
    if not alreadyADelayedItemUpdateCallback then
      alreadyADelayedItemUpdateCallback = true;
      C_Timer.After(0.1, UpdateItemCallback);
    end
		--for itemFrame in WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:EnumerateActive() do
		--	--WardrobeCollectionFrame.SetsCollectionFrame:SetItemFrameQuality(itemFrame);
    --  SetsFrame.HandleItemFrames(itemFrame, true);
		--end
	elseif ( event == "TRANSMOG_COLLECTION_UPDATED" ) then
    SetsFrame.InitializeSets();
    
		WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
		WardrobeCollectionFrame.SetsCollectionFrame:UpdateProgressBar();
		WardrobeCollectionFrame.SetsCollectionFrame:ClearLatestSource();
  elseif ( event == "TRANSMOG_COLLECTION_SOURCE_ADDED" ) then
    table.insert(SetsFrame.NewVisualIDs, C_TransmogCollection.GetSourceInfo(...).visualID);
    SetsFrame.LatestSource = ...;
  elseif ( event == "TRANSMOG_COLLECTION_SOURCE_REMOVED" ) then
    local visID = C_TransmogCollection.GetSourceInfo(...).visualID;
    for i=0,#SetsFrame.NewVisualIDs do
      if SetsFrame.NewVisualIDs[i] == visID then
        table.remove(SetsFrame.NewVisualIDs, i);
        break;
      end
    end
    if SetsFrame.LatestSource == ... then
      SetsFrame.LatestSource = nil;
    end
	end
end

----------for changing zoom limits with different races

--local SET_MODEL_PAN_AND_ZOOM_LIMITS = {
--	["Draenei2"] = { maxZoom = 2.2105259895325, panMaxLeft = -0.56983226537705, panMaxRight = 0.82581323385239, panMaxTop = -0.17342753708363, panMaxBottom = -2.6428601741791 },
--	["Draenei3"] = { maxZoom = 3.0592098236084, panMaxLeft = -0.33429977297783, panMaxRight = 0.29183092713356, panMaxTop = -0.079871296882629, panMaxBottom = -2.4141833782196 },
--	["Worgen2"] = { maxZoom = 1.9605259895325, panMaxLeft = -0.64045578241348, panMaxRight = 0.59410041570663, panMaxTop = -0.11050206422806, panMaxBottom = -2.2492413520813 },
--	["Worgen3"] = { maxZoom = 2.9013152122498, panMaxLeft = -0.2526838183403, panMaxRight = 0.38198262453079, panMaxTop = -0.10407017171383, panMaxBottom = -2.4137926101685 },
--	["Worgen3Alt"] = { maxZoom = 3.3618412017822, panMaxLeft = -0.19753229618072, panMaxRight = 0.26802557706833, panMaxTop = -0.073476828634739, panMaxBottom = -1.9255120754242 },
--	["Worgen2Alt"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.33268970251083, panMaxRight = 0.36896070837975, panMaxTop = -0.14780110120773, panMaxBottom = -2.1662468910217 },
--	["Scourge2"] = { maxZoom = 3.1710526943207, panMaxLeft = -0.3243542611599, panMaxRight = 0.5625838637352, panMaxTop = -0.054175414144993, panMaxBottom = -1.7261047363281 },
--	["Scourge3"] = { maxZoom = 2.7105259895325, panMaxLeft = -0.35650563240051, panMaxRight = 0.41562974452972, panMaxTop = -0.07072202116251, panMaxBottom = -1.877711892128 },
--	["Orc2"] = { maxZoom = 2.5526309013367, panMaxLeft = -0.64236557483673, panMaxRight = 0.77098786830902, panMaxTop = -0.075792260468006, panMaxBottom = -2.0818419456482 },
--	["Orc3"] = { maxZoom = 3.2960524559021, panMaxLeft = -0.22763830423355, panMaxRight = 0.32022559642792, panMaxTop = -0.038521766662598, panMaxBottom = -2.0473554134369 },
--	["Gnome3"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.29900181293488, panMaxRight = 0.35779395699501, panMaxTop = -0.076380833983421, panMaxBottom = -0.99909907579422 },
--	["Gnome2"] = { maxZoom = 2.8552639484406, panMaxLeft = -0.2777853012085, panMaxRight = 0.29651582241058, panMaxTop = -0.095201380550861, panMaxBottom = -1.0263166427612 },
--	["Dwarf2"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.50352156162262, panMaxRight = 0.4159924685955, panMaxTop = -0.07211934030056, panMaxBottom = -1.4946432113648 },
--	["Dwarf3"] = { maxZoom = 2.8947370052338, panMaxLeft = -0.37057432532311, panMaxRight = 0.43383255600929, panMaxTop = -0.084960877895355, panMaxBottom = -1.7173190116882 },
--	["BloodElf3"] = { maxZoom = 3.1644730567932, panMaxLeft = -0.2654082775116, panMaxRight = 0.28886350989342, panMaxTop = -0.049619361758232, panMaxBottom = -1.9943760633469 },
--	["BloodElf2"] = { maxZoom = 3.1710524559021, panMaxLeft = -0.25901651382446, panMaxRight = 0.45525884628296, panMaxTop = -0.085230752825737, panMaxBottom = -2.0548067092895 },
--	["Troll2"] = { maxZoom = 2.2697355747223, panMaxLeft = -0.58214980363846, panMaxRight = 0.5104039311409, panMaxTop = -0.05494449660182, panMaxBottom = -2.3443803787231 },
--	["Troll3"] = { maxZoom = 3.1249995231628, panMaxLeft = -0.35141581296921, panMaxRight = 0.50875341892242, panMaxTop = -0.063820324838161, panMaxBottom = -2.4224486351013 },
--	["Tauren2"] = { maxZoom = 2.1118416786194, panMaxLeft = -0.82946360111237, panMaxRight = 0.83975899219513, panMaxTop = -0.061676319688559, panMaxBottom = -2.035267829895 },
--	["Tauren3"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.37433895468712, panMaxRight = 0.40420442819595, panMaxTop = -0.1868137717247, panMaxBottom = -2.2116675376892 },
--	["NightElf3"] = { maxZoom = 2.9539475440979, panMaxLeft = -0.27334463596344, panMaxRight = 0.27148312330246, panMaxTop = -0.094710879027844, panMaxBottom = -2.3087983131409 },
--	["NightElf2"] = { maxZoom = 2.9144732952118, panMaxLeft = -0.45042458176613, panMaxRight = 0.47114592790604, panMaxTop = -0.10513981431723, panMaxBottom = -2.4612309932709 },
--	["Human3"] = { maxZoom = 3.3618412017822, panMaxLeft = -0.19753229618072, panMaxRight = 0.26802557706833, panMaxTop = -0.073476828634739, panMaxBottom = -1.9255120754242 },
--	["Human2"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.33268970251083, panMaxRight = 0.36896070837975, panMaxTop = -0.14780110120773, panMaxBottom = -2.1662468910217 },
--	["Pandaren3"] = { maxZoom = 2.5921046733856, panMaxLeft = -0.45187762379646, panMaxRight = 0.54132586717606, panMaxTop = -0.11439494043589, panMaxBottom = -2.2257535457611 },
--	["Pandaren2"] = { maxZoom = 2.9342107772827, panMaxLeft = -0.36421552300453, panMaxRight = 0.50203305482864, panMaxTop = -0.11241528391838, panMaxBottom = -2.3707413673401 },
--	["Goblin2"] = { maxZoom = 2.4605259895325, panMaxLeft = -0.31328883767128, panMaxRight = 0.39014467597008, panMaxTop = -0.089733943343162, panMaxBottom = -1.3402827978134 },
--	["Goblin3"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.26144406199455, panMaxRight = 0.30945864319801, panMaxTop = -0.07625275105238, panMaxBottom = -1.2928194999695 },
--	["LightforgedDraenei2"] = { maxZoom = 2.2105259895325, panMaxLeft = -0.56983226537705, panMaxRight = 0.82581323385239, panMaxTop = -0.17342753708363, panMaxBottom = -2.6428601741791 },
--	["LightforgedDraenei3"] = { maxZoom = 3.0592098236084, panMaxLeft = -0.33429977297783, panMaxRight = 0.29183092713356, panMaxTop = -0.079871296882629, panMaxBottom = -2.4141833782196 },
--	["HighmountainTauren2"] = { maxZoom = 2.1118416786194, panMaxLeft = -0.82946360111237, panMaxRight = 0.83975899219513, panMaxTop = -0.061676319688559, panMaxBottom = -2.035267829895 },
--	["HighmountainTauren3"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.37433895468712, panMaxRight = 0.40420442819595, panMaxTop = -0.1868137717247, panMaxBottom = -2.2116675376892 },
--	["Nightborne3"] = { maxZoom = 2.9539475440979, panMaxLeft = -0.27334463596344, panMaxRight = 0.27148312330246, panMaxTop = -0.094710879027844, panMaxBottom = -2.3087983131409 },
--	["Nightborne2"] = { maxZoom = 2.9144732952118, panMaxLeft = -0.45042458176613, panMaxRight = 0.47114592790604, panMaxTop = -0.10513981431723, panMaxBottom = -2.4612309932709 },
--	["VoidElf3"] = { maxZoom = 3.1644730567932, panMaxLeft = -0.2654082775116, panMaxRight = 0.28886350989342, panMaxTop = -0.049619361758232, panMaxBottom = -1.9943760633469 },
--	["VoidElf2"] = { maxZoom = 3.1710524559021, panMaxLeft = -0.25901651382446, panMaxRight = 0.45525884628296, panMaxTop = -0.085230752825737, panMaxBottom = -2.0548067092895 },
--	["MagharOrc2"] = { maxZoom = 2.5526309013367, panMaxLeft = -0.64236557483673, panMaxRight = 0.77098786830902, panMaxTop = -0.075792260468006, panMaxBottom = -2.0818419456482 },
--	["MagharOrc3"] = { maxZoom = 3.2960524559021, panMaxLeft = -0.22763830423355, panMaxRight = 0.32022559642792, panMaxTop = -0.038521766662598, panMaxBottom = -2.0473554134369 },
--	["DarkIronDwarf2"] = { maxZoom = 2.9605259895325, panMaxLeft = -0.50352156162262, panMaxRight = 0.4159924685955, panMaxTop = -0.07211934030056, panMaxBottom = -1.4946432113648 },
--	["DarkIronDwarf3"] = { maxZoom = 2.8947370052338, panMaxLeft = -0.37057432532311, panMaxRight = 0.43383255600929, panMaxTop = -0.084960877895355, panMaxBottom = -1.7173190116882 },
--	["KulTiran2"] = { maxZoom =  1.71052598953247, panMaxLeft = -0.667941331863403, panMaxRight = 0.589463412761688, panMaxTop = -0.373320609331131, panMaxBottom = -2.7329957485199 },
--	["KulTiran3"] = { maxZoom =  2.22368383407593, panMaxLeft = -0.43183308839798, panMaxRight = 0.445900857448578, panMaxTop = -0.303212702274323, panMaxBottom = -2.49550628662109 },
--	["ZandalariTroll2"] = { maxZoom =  2.1710512638092, panMaxLeft = -0.487841755151749, panMaxRight = 0.561356604099274, panMaxTop = -0.385127544403076, panMaxBottom = -2.78562784194946 },
--	["ZandalariTroll3"] = { maxZoom =  3.32894563674927, panMaxLeft = -0.376705944538116, panMaxRight = 0.488780438899994, panMaxTop = -0.20890490710735, panMaxBottom = -2.67064166069031 },
--};

local function ExS_UpdatePanAndZoomModelType()
local a, b = C_TransmogSets.GetCameraIDs();

	local hasAlternateForm, inAlternateForm = HasAlternateForm();
	--if ( not panAndZoomModelType or inAltForm ~= inAlternateForm ) then
		local raceInfo = C_CreatureInfo.GetRaceInfo(currentRaceID);
    
    local race = raceInfo.clientFileString;
		local sex;
    if (displayBools.displayFemale == 1) then sex = 3; else sex = 2; end
		if ( inAlternateForm ) then
			WardrobeCollectionFrame.SetsCollectionFrame.Model.panAndZoomModelType = race..sex.."Alt";
		else
			WardrobeCollectionFrame.SetsCollectionFrame.Model.panAndZoomModelType = race..sex;
		end
	--	inAltForm = inAlternateForm;
	--end
end

function ExS_OnModelLoaded()
	if ( WardrobeCollectionFrame.SetsCollectionFrame.Model.cameraID ) then
  --print("Inside If");
		Model_ApplyUICamera(WardrobeCollectionFrame.SetsCollectionFrame.Model, WardrobeCollectionFrame.SetsCollectionFrame.Model.cameraID);
    
    local limits = WardrobeCollectionFrame.SetsCollectionFrame.Model:GetPanAndZoomLimits();
    posY = ((limits.panMaxRight - limits.panMaxLeft) * 0.5) + limits.panMaxLeft;
    posZ = ((limits.panMaxTop - limits.panMaxBottom) * 0.5) + limits.panMaxBottom;
    
    
    
    WardrobeCollectionFrame.SetsCollectionFrame.Model.defaultPosX = -limits.maxZoom * 0.1;
    posX = WardrobeCollectionFrame.SetsCollectionFrame.Model.defaultPosX;
    WardrobeCollectionFrame.SetsCollectionFrame.Model:SetPosition(posX, posY, posZ);
    
    WardrobeCollectionFrame.SetsCollectionFrame:RefreshCameras();
	end
end
local function ExS_OnMouseWheel(self, delta)
	local posX, posY, posZ = WardrobeCollectionFrame.SetsCollectionFrame.Model:GetPosition();
	posX = posX + delta * 0.5;
	local limits = WardrobeCollectionFrame.SetsCollectionFrame.Model:GetPanAndZoomLimits();
	WardrobeCollectionFrame.SetsCollectionFrame.Model:SetPosition(posX, posY, posZ);
end

local function GetDisplaySetInfo(setID)
  local setinfo;
  if (VariantSetsIDs[setID] ~= nil) then
    setinfo = VariantSets[VariantSetsIDs[setID]];
  else
    setinfo = BaseSets[setID];
  end
  return setinfo.name, setinfo.label, setinfo.limitedTimeSet, setinfo.description, setinfo.requiredFaction, setinfo.note, setinfo.noLongerObtainable;
end

--Handles Setting or Refreshing the collection based appearances for the row of ItemFrames.
local function HandleItemFrames(itemFrame, forceItemFrameDataUpdate)
  if (forceItemFrameDataUpdate) then
    SetsFrame.DisplaySet();
    return;
  end
  
  itemFrameType = itemFrame.itemFrameType;
  if not ExS_Settings.showCharCollectionIcons then
    if itemFrameType == "CollectedCharCantUse" or itemFrameType == "CollectedCharCantGet" then
      itemFrameType = "Collected";
    elseif itemFrameType == "NotCollectedCharCantGet" then
      itemFrameType = "NotCollected";
    end
  end
  
  itemFrame.IconBorder:Show();
  
  if itemFrameType == "Collected" then
    itemFrame.Icon:SetDesaturated(false);
    itemFrame.IconBorder:SetDesaturation(0);
    
    itemFrame.IconBorder:ClearAllPoints();
    itemFrame.IconBorder:SetPoint("RIGHT",itemFrame,"CENTER", 20, 1);
    itemFrame.IconBorder:SetVertexColor(1,1,1);
    itemFrame.IconBorder:SetAtlas(nil);
    WardrobeCollectionFrame.SetsCollectionFrame:SetItemFrameQuality(itemFrame);
    
    itemFrame.Icon:SetAlpha(1);
    itemFrame.IconBorder:SetAlpha(1);
    
    local transmogSlot = C_Transmog.GetSlotForInventoryType(itemFrame.invType);
    if ( C_TransmogSets.SetHasNewSourcesForSlot(itemFrame.setID, transmogSlot) ) then
      itemFrame.New:Show();
      itemFrame.New.Anim:Play();
    elseif #SetsFrame.NewVisualIDs > 0 then
      local itemFrameVisID = C_TransmogCollection.GetSourceInfo(itemFrame.sourceID).visualID;
      local setNew = false;
      for i = 1,#SetsFrame.NewVisualIDs do
        if SetsFrame.NewVisualIDs[i] == itemFrameVisID then
          setNew = true;
          itemFrame.New:Show();
          itemFrame.New.Anim:Play();
          break;
        end
      end
      if not setNew then
        itemFrame.New:Hide();
        itemFrame.New.Anim:Stop();
      end;
    else
      itemFrame.New:Hide();
      itemFrame.New.Anim:Stop();
    end
    
  elseif itemFrameType == "CollectedCharCantUse" then
    itemFrame.Icon:SetDesaturated(false);
    itemFrame.IconBorder:SetDesaturation(0);
    
    itemFrame.IconBorder:ClearAllPoints();
    itemFrame.IconBorder:SetPoint("CENTER",itemFrame,"TOP",0,-3);
    itemFrame.IconBorder:SetVertexColor(1,0.8,0);
    itemFrame.IconBorder:SetAtlas("PlayerRaidBlip");
    itemFrame.IconBorder:SetSize(25,25);
    
    itemFrame.Icon:SetAlpha(0.6);
    itemFrame.IconBorder:SetAlpha(0.5);
    
    local transmogSlot = C_Transmog.GetSlotForInventoryType(itemFrame.invType);
    if ( C_TransmogSets.SetHasNewSourcesForSlot(itemFrame.setID, transmogSlot) ) then
      itemFrame.New:Show();
      itemFrame.New.Anim:Play();
    elseif #SetsFrame.NewVisualIDs > 0 then
      local itemFrameVisID = C_TransmogCollection.GetSourceInfo(itemFrame.sourceID).visualID;
      local setNew = false;
      for i = 1,#SetsFrame.NewVisualIDs do
        if SetsFrame.NewVisualIDs[i] == itemFrameVisID then
          setNew = true;
          itemFrame.New:Show();
          itemFrame.New.Anim:Play();
          break;
        end
      end
      if not setNew then
        itemFrame.New:Hide();
        itemFrame.New.Anim:Stop();
      end
    else
      itemFrame.New:Hide();
      itemFrame.New.Anim:Stop();
    end
    
  elseif itemFrameType == "CollectedCharCantGet" then
    itemFrame.Icon:SetDesaturated(false);
    itemFrame.IconBorder:SetDesaturation(0);
    
    itemFrame.IconBorder:ClearAllPoints();
    itemFrame.IconBorder:SetPoint("CENTER",itemFrame,"TOP",0,-3);
    itemFrame.IconBorder:SetVertexColor(1,0,0);
    itemFrame.IconBorder:SetAtlas("PlayerRaidBlip");
    itemFrame.IconBorder:SetSize(25,25);
    
    itemFrame.Icon:SetAlpha(0.6);
    itemFrame.IconBorder:SetAlpha(0.5);
    itemFrame.New:Hide();
  
  elseif itemFrameType == "NotCollectedCharCantGet" then
    itemFrame.Icon:SetDesaturated(true);
    itemFrame.IconBorder:SetDesaturation(0);
    
    itemFrame.IconBorder:ClearAllPoints();
    itemFrame.IconBorder:SetPoint("CENTER",itemFrame,"TOP",0,-3);
    itemFrame.IconBorder:SetVertexColor(1,0,0);
    itemFrame.IconBorder:SetAtlas("PlayerDeadBlip");
    itemFrame.IconBorder:SetSize(25,25);
    
    itemFrame.Icon:SetAlpha(0.3);
    itemFrame.IconBorder:SetAlpha(0.5);
    itemFrame.New:Hide();
    
  elseif itemFrameType == "NotCollected" then
    itemFrame.IconBorder:SetAtlas(nil);
    WardrobeCollectionFrame.SetsCollectionFrame:SetItemFrameQuality(itemFrame);
    itemFrame.IconBorder:SetVertexColor(1,1,1,0.5);
    
    itemFrame.Icon:SetDesaturated(true);
    itemFrame.Icon:SetAlpha(0.3);
    itemFrame.New:Hide();
  end
end

local function HideDisplay()
	WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame:Hide();
	WardrobeCollectionFrame.SetsCollectionFrame.Model:Hide();
end

local firstOpening = 0;

local function DisplaySet()
  if #BaseList == 0 then HideDisplay(); return; end
  
	local setID = WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID();

  local name, label, limitedTimeSet, description, requiredFaction, note, noLongerObtainable = GetDisplaySetInfo(setID);
  
	WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame:Show();
	WardrobeCollectionFrame.SetsCollectionFrame.Model:Show();

	WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Name:SetText(name);
	if ( WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Name:IsTruncated() ) then
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Name:Hide();
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LongName:SetText(name);
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LongName:Show();
	else
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Name:Show();
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LongName:Hide();
	end
  if note then
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Label:SetText(note);
  else
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.Label:SetText(label);
  end
  
  WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet:Show();
  if (requiredFaction ~= nil and requiredFaction ~= factionNames.playerFaction) then
    local atlas;
    if (requiredFaction == "Horde") then
      atlas = "worldquest-icon-horde";
      WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Text:SetText(ITEM_REQ_HORDE);
    else
      atlas = "worldquest-icon-alliance";
      WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Text:SetText(ITEM_REQ_ALLIANCE);
    end
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Icon:SetAtlas(atlas);
  elseif limitedTimeSet then
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Text:SetText(TRANSMOG_SET_LIMITED_TIME_SET);
    --WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Text:SetText(TRANSMOG_SET_LIMITED_TIME_SET);--factionNames.opposingFaction);--.." only");
  elseif noLongerObtainable then
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Icon:SetAtlas("transmog-icon-remove");
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet.Text:SetText("No longer obtainable.");
  else
    WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.LimitedSet:Hide();
  end
	
	--local newSourceIDs = C_TransmogSets.GetSetNewSources(setID);

	WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:ReleaseAll();
	local sortedSources = GetSortedSetSources(setID);
  local buttonSizing = { 37, -floor((#sortedSources - 1) * 37 / 2) };
  
  
    --WardrobeCollectionFrame.SetsCollectionFrame.Model:SetCustomRace(4, 1);
  WardrobeCollectionFrame.SetsCollectionFrame.Model:Undress()

  --Weird workaround to fix an issue with patch 9.1 that made the model not work when first shown. Seems to be something important to the model is delayed and forcing it to show/hide a few times fixes it.
  if firstOpening < 7 then
    WardrobeCollectionFrame.SetsCollectionFrame.Model:Hide();
    WardrobeCollectionFrame.SetsCollectionFrame.Model:Show();
    firstOpening = firstOpening + 1;
  end

	for i = 1, #sortedSources do
		local itemFrame = WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:Acquire();
    
    itemFrame:SetScript("OnEnter",SetsFrame.AppearanceTooltipOnEnter);
  
    itemFrame.sourceID = SplitModedID(sortedSources[i].sourceID);
		itemFrame.itemID = sortedSources[i].itemID;
    itemFrame.setID = setID;
		itemFrame.collected = sortedSources[i].collected;
		itemFrame.invType = sortedSources[i].invType;
		itemFrame.Icon:SetTexture(C_TransmogCollection.GetSourceIcon(itemFrame.sourceID));
    itemFrame.IconBorder:Hide();
    
    if ( sortedSources[i].collected ) then
      if sortedSources[i].isCollectedChar then
        itemFrame.itemFrameType = "Collected";
      else
        if sortedSources[i].canCharCollectIt then
          itemFrame.itemFrameType = "CollectedCharCantUse";
        else
          itemFrame.itemFrameType = "CollectedCharCantGet";
        end
      end
		else
      if (not sortedSources[i].canCharCollectIt) then
        itemFrame.itemFrameType = "NotCollectedCharCantGet";
      else
        itemFrame.itemFrameType = "NotCollected";
      end
    end
    HandleItemFrames(itemFrame, false);
    
    itemFrame:SetScript("OnMouseDown", SetsFrame.ExS_SetSources_OnMouseDown);
		itemFrame:SetPoint("TOP", WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame, "TOP", buttonSizing[2] + (i - 1) * buttonSizing[1], -94);
		itemFrame:Show();

    --print(itemFrame.sourceID);print(select(6, C_TransmogCollection.GetAppearanceSourceInfo(itemFrame.sourceID)));
    WardrobeCollectionFrame.SetsCollectionFrame.Model:TryOn(select(6, C_TransmogCollection.GetAppearanceSourceInfo(itemFrame.sourceID)))
	end

	-- variant sets
	local variantSets = GetVariantSets(GetBaseSetID(setID));
	if ( #variantSets <= 1 )  then
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.VariantSetsButton:Hide();
	else
		WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.VariantSetsButton:Show();
    if description == nil then
      WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.VariantSetsButton:SetText(name);
    else
      WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.VariantSetsButton:SetText(description);
    end
	end
end



--Optimization for narrowing search values.
local oldSearchValue = "";
--local oldCollectedFilter = nil;
--local oldNotCollectedFilter = nil;
--local oldPvEFilter = nil;
--local oldPvPFilter = nil;

local function SearchValueFound(set, searchValue)
  local start, _ = string.find(string.lower(set.name), searchValue);
  if start ~= nil then return true; end
  
  if set.label == nil then return false; end
  
  start, _ = string.find(string.lower(set.label), searchValue);
  if start ~= nil then return true; end
  
  return false;
end

--Update the list of sets based on the current search parameter (searching the name and source of the set).
local function OnSearchUpdate()
  --local showCollected = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED);
  --local showNotCollected = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED);
  --local showPvE = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE);
  --local showPvP = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP);
  
  local searchValue = string.lower(WardrobeCollectionFrameSearchBox:GetText());
  
  local updateSearchValueStart = string.find(searchValue, oldSearchValue);
  --local tableToSearch;
  --if oldCollectedFilter == nil then
  --  oldCollectedFilter = showCollected;
  --  oldNotCollectedFilter = showNotCollected;
  --  oldPvEFilter = showPvE;
  --  oldPvPFilter = showPvP;
  --elseif ((oldCollectedFilter == showCollected) and
  --    (oldNotCollectedFilter == showNotCollected) and
  --    (oldPvEFilter == showPvE) and
  --    (oldPvPFilter == showPvP) and
  if    (updateSearchValueStart == 1 and strlen(oldSearchValue) < strlen(searchValue)) then
    for i = #BaseList, 1, -1 do
      if not SearchValueFound(BaseList[i], searchValue) then
        table.remove(BaseList, i);
      end
    end
    --OnSearchUpdatePart1(searchValue);
    --for i = #BaseList, 1, -1 do
    --  --local isPvP = GetBaseSetData(BaseList[i].setID).isPvP;
    --  
    --  --if (((not BaseList[i].collected) and showCollected) and
    --  --    (GetBaseSetData(BaseList[i].setID).allCompleted and showNotCollected)) then
    --  --  table.remove(BaseList, i);  
    --  --elseif (isPvP and (not showPvP)) or ((not isPvP) and (not showPvE)) then
    --  --  table.remove(BaseList, i); 
    --  --else
    --    local start, _ = string.find(string.lower(BaseList[i].name), searchValue);
    --    if (start == nil) then
    --      if (BaseList[i].label ~= nil) then
    --        start, _ = string.find(string.lower(BaseList[i].label), searchValue);
    --        
    --        if (start == nil) then
    --          table.remove(BaseList, i);
    --        end
    --      else
    --        table.remove(BaseList, i);
    --      end
    --    end
    --  --end
    --end
  else
    wipe(BaseList);
    
    for _, baseSet in pairs(BaseSets) do
      local useSet = SetsFrame.UseSet(baseSet);
      if useSet and SearchValueFound(baseSet, searchValue) then
        table.insert(BaseList, baseSet);
      end
    end
    --OnSearchUpdatePart2(searchValue);
--    for _, baseSet in pairs(BaseSets) do
--      local bSet = baseSet;
--      if UseSet(bSet) then
-- --     --if heritageSets[baseSet.setID] == nil or heritageSets[baseSet.setID] == currentRaceID then
-- --     --  local isPvP = GetBaseSetData(baseSet.setID).isPvP;
-- --     --  
-- --     --  if ( ((baseSet.collected and showCollected) or
-- --     --        ((not GetBaseSetData(baseSet.setID).allCompleted) and showNotCollected)) and
-- --     --      ((isPvP and showPvP) or ((not isPvP) and showPvE)) ) then
--          local start, _ = string.find(string.lower(baseSet.name), searchValue);
--          if (start ~= nil) then
--            table.insert(BaseList, bSet);
--          else if (bSet.label ~= nil) then
--            start, _ = string.find(string.lower(baseSet.label), searchValue);
--            
--            if (start ~= nil) then
--              table.insert(BaseList, baseSet);
--            end
--          end
--        --  end
-- --     --  end
--      end
--    end
    SetsFrame.SortSets(BaseList, false);
  end
  
  --local scrollMax = max((#BaseList - _ButtonsInFrame) * 46, 0);
  --ExS_ScrollFrame.scrollBar:SetMinMaxValues(0, scrollMax);
	--ExS_ScrollFrame.range = #BaseList * 46;
  
  oldSearchValue = searchValue;
  --oldCollectedFilter = showCollected;
  --oldNotCollectedFilter = showNotCollected;
  --oldPvEFilter = showPvE;
  --oldPvPFilter = showPvP;
  SetsFrame.ExS_ScrollFrame_Update();
  --if #BaseList > 0 then
  if #BaseList > 0 then --Can happen if you set filters in a way to make an empty list.
    WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
  end
end

--Update Heritage Armors when the selected race is changed.
local function UpdateBaseListHeritageArmors(oldRace, newRace)
  local heritageToRemove = nil;
  local heritageToAdd = nil;
  for heritageID,raceID in pairs(heritageSets) do
    if raceID == oldRace then
      heritageToRemove = heritageID;
    end
    if raceID == newRace then
      heritageToAdd = heritageID;
    end
  end
  if heritageToRemove then
    for i = 1, #BaseList do
      if BaseList[i].setID == heritageToRemove then
        table.remove(BaseList, i);
        break;
      end
    end
  end
  if heritageToAdd ~= nil then
    table.insert(BaseList, BaseSets[heritageToAdd]);
    SetsFrame.SortSets(BaseList, false);
  end
end

--Create a drop down to select the variants of the selected set.
local function OpenVariantSetsDropDown()
	local selectedSetID = WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID();
  
	if ( not selectedSetID ) then
		return;
	end
	local info = UIDropDownMenu_CreateInfo();
	local baseSetID = GetBaseSetID(selectedSetID);
  
  local prevClass = 0;
	local variantSets = GetVariantSets(baseSetID, true);
  
	for i = 1, #variantSets do
		local variantSet = variantSets[i];
    
    if (prevClass ~= variantSet.classMask and GetColoredClassNameString(variantSet.classMask) ~= "") then
      info.text = GetColoredClassNameString(variantSet.classMask);
      info.notCheckable = true;
      info.func = function() WardrobeCollectionFrame.SetsCollectionFrame.SelectSet(variantSet.setID, true); end;
      UIDropDownMenu_AddButton(info);
      
      prevClass = variantSet.classMask;
    end
    
    local variantID = variantSet.setID;
      
		local numSourcesCollected, numSourcesTotal = GetSetSourceCounts(variantID);
		local colorCode = colors.IN_PROGRESS_FONT_COLOR_CODE;
    
		if ( numSourcesCollected == numSourcesTotal ) then
			colorCode = NORMAL_FONT_COLOR_CODE;
		elseif ( numSourcesCollected == 0 ) then
			colorCode = GRAY_FONT_COLOR_CODE;
		end
    
    local desc = variantSet.description;
    if desc == nil then
      desc = variantSet.name;
    end
    if variantSet.requiredFaction ~= nil then
      desc = GetFactionColoredString(desc, variantSet.requiredFaction)
    end
    
		info.text = format(ITEM_SET_NAME, desc..colorCode, numSourcesCollected, numSourcesTotal);
    info.notCheckable = false;
		info.checked = (variantSet.setID == selectedSetID);
		info.func = function() WardrobeCollectionFrame.SetsCollectionFrame.SelectSet(variantSet.setID, true); end;
		UIDropDownMenu_AddButton(info);
	end
end

--Interpolate between two colors.
local function MergeColors(color1, color2, t)
  if t == 1 then
    return color2;
  elseif t == 0 then
    return color1;
  end

  local Cmax = max(color1.r, color1.g, color1.b);
  local Cmin = min(color1.r, color1.g, color1.b);
  local delta = Cmax - Cmin;
  
  local hue1;
  if delta == 0 then hue1 = 0;
  elseif Cmax == color1.r then
    hue1 = (((color1.g - color1.b) / delta));
  elseif Cmax == color1.g then
    hue1 = (((color1.b - color1.r) / delta) + 2);
  elseif Cmax == color1.b then
    hue1 = (((color1.r - color1.g) / delta) + 4);
  end
  if hue1 < 0 then hue1 = hue1 + 6; end
  local sat1 = 0;
  if Cmax ~= 0 then sat1 = delta / Cmax; end
  local val1 = Cmax;
  
  Cmax = max(color2.r, color2.g, color2.b);
  Cmin = min(color2.r, color2.g, color2.b);
  delta = Cmax - Cmin;
  
  local hue2;
  if delta == 0 then hue1 = 0;
  elseif Cmax == color2.r then
    hue2 = (((color2.g - color2.b) / delta));
  elseif Cmax == color2.g then
    hue2 = (((color2.b - color2.r) / delta) + 2);
  elseif Cmax == color2.b then
    hue2 = (((color2.r - color2.g) / delta) + 4);
  end
  if hue2 < 0 then hue2 = hue2 + 6; end
  local sat2 = 0;
  if Cmax ~= 0 then sat2 = delta / Cmax; end
  local val2 = Cmax;
    
  local angle = ((hue2 - hue1) + 3) % 6 - 3;
  
  local hue = hue1 + (angle * t) % 6;
  local sat = sat1 * (1.0 - t) + sat2 * t;
  local val = val1 * (1.0 - t) + val2 * t;
  
  local i = floor(hue);
  local f = hue - i;
  local p = val * (1 - sat);
  local q = val * (1 - sat * f);
  local t = val * (1 - sat * (1 - f));
  
  local retColor = {};
  if i == 0 then
    retColor.r = val;
    retColor.g = t;
    retColor.b = p;
  elseif i == 1 then
    retColor.r = q;
    retColor.g = val;
    retColor.b = p;
  elseif i == 2 then
    retColor.r = p;
    retColor.g = val;
    retColor.b = t;
  elseif i == 3 then
    retColor.r = p;
    retColor.g = q;
    retColor.b = val;
  elseif i == 4 then
    retColor.r = t;
    retColor.g = p;
    retColor.b = val;
  else
    retColor.r = val;
    retColor.g = p;
    retColor.b = q;
  end
  return retColor;
end

--Sets the Progress Bar at the top of the sets window.
local function UpdateProgressBar()
  --if (numberSets == nil) then
    CalculateCount();
  --end
	
	WardrobeCollectionFrame.progressBar:SetMinMaxValues(46, setStats.numberSets);
  WardrobeCollectionFrame.progressBar:SetValue(setStats.numberCollected);
	WardrobeCollectionFrame.progressBar.text:SetFormattedText(HEIRLOOMS_PROGRESS_FORMAT, setStats.numberCollected, setStats.numberSets);
  local percent = setStats.numberCollected / setStats.numberSets;
  
  local color = MergeColors(colors.LOW_PROGRESS_COLOR, colors.IN_PROGRESS_FONT_COLOR, percent);
  WardrobeCollectionFrame.progressBar:SetStatusBarColor(color.r, color.g, color.b);
end

-----------------------------------------------------------------------------------------------------------
  --Set Map/List/Hash Creation/Management--
-----------------------------------------------------------------------------------------------------------
--Fills in a list of Race IDs and localized Names.
local function InitRaceIDs()
  for _,id in pairs(raceIDs) do
    table.insert(raceList, {raceID = id, raceName = C_CreatureInfo.GetRaceInfo(id).raceName});
  end
  
  local comparison = function(race1,race2)
                      if race1.raceName < race2.raceName then return true; end
                      return false;
                     end
	table.sort(raceList, comparison);
end

--Fills in the Class Name (localized) and the Index (for reading into the class masks map).
local function SetClassIDs(armorType)
	local localizedClass, _, classInd = UnitClass('player');
  if armorType then
    ArmorTypeRadio[armorType] = true;
    if armorType == ClassArmorType[classInd] then
      ClassName = localizedClass;
      ClassIndex = classInd;
      return;
    end
  
    for i,j in pairs(ClassArmorType) do
      if j == armorType then ClassName, _, ClassIndex = GetClassInfo(i); break; end
    end
    
  else
    ClassName = localizedClass;
    ClassIndex = classInd;
    _,_,currentRaceID = UnitRace('player');
    defaultSex = UnitSex('player') - 2;
    InitRaceIDs();
  end
end

local garbageCount = 0;
local function CollectTheGarbage()
  garbageCount = garbageCount + 1;
  if garbageCount == maxGarbage then
    collectgarbage();
    garbageCount = 0;
  end
end

local function ClearSets()
  alreadyFilled = false;
  wipe(BaseList);
  BaseList = {};
  wipe(BaseSets);
  BaseSets = {};
  wipe(BaseSetsPvPFlag);
  BaseSetsPvPFlag = {};
  wipe(BaseSetsData);
  BaseSetsData = {};
  wipe(VariantSets);
  VariantSets = {};
  wipe(VariantSetsIDs);
  VariantSetsIDs = {};
  
  CollectTheGarbage();
end

local function InitializeSets(armorType, force)
  if (force == false) and armorType and ArmorTypeRadioIsChecked[armorType] then return; end

  ClearSets();
  SetClassIDs(armorType);
  SetsFrame.FillSetMaps();
  
  --local scrollMax = max((#BaseList - _ButtonsInFrame) * 46, 0);
  --ExS_ScrollFrame.scrollBar:SetMinMaxValues(0, scrollMax);
	--ExS_ScrollFrame.range = #BaseList * 46;
  
	local firstSet = nil;
	for _,set in pairs(BaseList) do
		firstSet = set;
		break;
	end
  if firstSet ~= nil then
    ExS_ScrollFrame.selectedSetID = firstSet.setID;
    WardrobeCollectionFrame.SetsCollectionFrame.selectedSetID = firstSet.setID;
  end
  
  if not armorType then
    armorType = ClassArmorType[ClassIndex];
  end
  --if armorType then 
    for i=1,4 do
      ArmorTypeRadioIsChecked[i] = false;
      if i == armorType then
        ArmorTypeRadioIsChecked[i] = true;
      end
    end
    func_ScrollToOffset(1);
  --end
  
  if firstSet ~= nil then
    SetsFrame.SelectSet(firstSet.setID);
  end
  SetsFrame.ScrollToOffset(1, true, false, true);
  UpdateProgressBar();
end

local function AddSetToHash(set, placeToPut)
  local checkIfOtherVar = VariantSets[placeToPut];
  
  local i = placeToPut;
  while (checkIfOtherVar ~= nil) do
    i = i + 1;
    checkIfOtherVar = VariantSets[i];
  end
    
  VariantSets[i] = set;
  VariantSetsIDs[set.setID] = i;
  return i;
end

local function RemoveSetFromHash(set)
  local checkIfOtherVar = VariantSets[set.baseSetID];
  
  local i = set.baseSetID;
  while (checkIfOtherVar.setID ~= set.setID) do
    i = i + 1;
    checkIfOtherVar = VariantSets[i];
  end
  
  VariantSetsIDs[VariantSets[i].setID] = nil;
  VariantSets[i] = nil;
  i = i + 1;
  checkIfOtherVar = VariantSets[i];
  
  
  while (checkIfOtherVar ~= nil) do
    for j = i, checkIfOtherVar.baseSetID, -1 do
      if (VariantSets[j] == nil) then
        VariantSets[j] = checkIfOtherVar;
        VariantSetsIDs[VariantSets[j].setID] = j;
        VariantSets[i] = nil;
      end
    end
  
    i = i + 1;
    checkIfOtherVar = VariantSets[i];
  end
end

--Sort the given set.
local function SortSets(sets, reverseUIOrder)
	local comparison = function(set1, set2)
		local groupFavorite1 = set1.favoriteSetID and true;
		local groupFavorite2 = set2.favoriteSetID and true;
		if ( groupFavorite1 ~= groupFavorite2 ) then
			return groupFavorite1;
		end
		--if ( set1.favorite ~= set2.favorite ) then
		--	return set1.favorite;
		--end
    if heritageSets[set1.setID] ~= nil and heritageSets[set2.setID] == nil then return true; end
    if heritageSets[set2.setID] ~= nil and heritageSets[set1.setID] == nil then return false; end
    if set1.label == "Special" then return true; end
    if set2.label == "Special" then return false; end
		if ( set1.expansionID ~= set2.expansionID ) then
			return set1.expansionID > set2.expansionID;
		end
		if ( set1.patchID ~= set2.patchID ) then
			return set1.patchID > set2.patchID;
		end
		if ( set1.uiOrder ~= set2.uiOrder ) then
			if ( reverseUIOrder ) then
				return set1.uiOrder < set2.uiOrder;
			else
				return set1.uiOrder > set2.uiOrder;
			end
		end
		return set1.setID > set2.setID;
	end

	table.sort(sets, comparison);
end

local function HideBlizzardSets(setID)
  local setsToHide = {1822,1823, -- BfA Brawler's Garb (horde and alliance versions)
                      1902, -- Renowned Explorer's Attire
    };
  
  for i = 1, #setsToHide do
    if setID == setsToHide[i] then
      return true;
    end
  end
  return false;
end

local function UseSet(data)
  -- If this is a set to hide, don't display it.
  if HideBlizzardSets(data.setID) then return false; end
  -- If it is a Heritage set, show/hide if for current race.
  if heritageSets[data.setID] ~= nil then
    if heritageSets[data.setID] == currentRaceID then
      return true;
    else
      return false;
    end
  end
  -- If this the other faction and we are not showing other faction, don't display it.
  if (data.requiredFaction ~= nil and data.requiredFaction ~= factionNames.playerFaction) and (ExS_Settings.displayOtherFaction == false) then return false; end
  -- If this is from an expansion that is hidden, don't show it.
  if data.expansionID > -1 and not ExS_Settings.expansionToggles[data.expansionID + 1] then return false; end
  -- If we are hiding no longer obtainable and this set applies, don't show it.
  if (data.noLongerObtainable and ExS_Settings.hideNoLongerObtainable) then return false; end
  
  -- Show/Hide based on collection filters.
  local setSourceData = GetSetSourceData(data.setID, GetSetSources(data.setID, data))--GetSetSourceCounts(data.setID)
  local collected;
  if setSourceData == nil then
    collected = false;
  else
    collected = setSourceData.numCollected == setSourceData.numTotal;
  end
  
  if not ((collected and C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED)) or
     (not collected and C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED))) then
     return false;
  end
  --if not showBasedOnCollection then return false; end
  
  -- Show/Hide based on PvP/PvE filters.
  if data.description ~= nil then
    local dataDescription = data.description;
    if (string.sub(data.description,1,1) == "|") then
      dataDescription = string.sub(data.description, 12, -3)
    end
    local isPvP = pvpDescriptions[dataDescription] or false;
    if not ((isPvP and C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP)) or
       (not isPvP and C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE))) then
        return false;
    end
  elseif not C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE) then
    return false;
  end
  
  -- Check for correct class. (Or corect weight if displayOnlyMyClass is not checked).
  local ClassArmors = ClassMaskMap[ClassIndex];
  if ExS_Settings.displayOnlyMyClass then
    if ClassIndex == nil or ClassIndex == select(3,UnitClass('player')) then
      ClassArmors = ClassArmorMask[ClassIndex];
    end
  end
  
  local classCorrect = false;
  for i = 1, #ClassArmors do
    if data.classMask == ClassArmors[i] then
      classCorrect = true;
      break;
    end
  end
  if not classCorrect then return false; end
  
  return true;
end

local function CombineIntoSpecial(setID)
  local setsToCombine = {
        1903, -- Wendigo Woolies
        1913, -- Vestments of the Eternal Traveler
        1914, -- Sprite Darter's Wings
    };
    
  for i = 1, #setsToCombine do
    if setID == setsToCombine[i] then
      return true;
    end
  end
  return false;
end


local function IsFavorite(setID)
  for i=1,#ExS_Favorites do
    if ExS_Favorites[i] == setID then
      return true;
    end
  end
  return false;
end

--Fills the Set Maps.
local function FillSetMaps()
  local sets = C_TransmogSets.GetAllSets();

  factionNames.playerFaction, _ = UnitFactionGroup('player');
  if factionNames.playerFaction == "Alliance" then
    factionNames.opposingFaction = "Horde";
  else
    factionNames.opposingFaction = "Alliance";
  end
  local favoritesToSet = {};
  
  local firstSpecialSet = nil;

  for index, data in ipairs(sets) do
    if IsFavorite(data.setID) then
      data.favorite = true;
      data.favoriteSetID = data.setID;
    else
      data.favorite = false;
      data.favoriteSetID = nil;
    end
    --If it was an old Rated armor set, flag it as no longer obtainable.
    if (data.description == "Elite") and not data.limitedTimeSet then
      data.noLongerObtainable = true;
    end
    --Flag the Pandaria Challenge Mode Dungeons as no longer obtainable.
    if data.label == "Pandaria Challenge Dungeons" then
      data.noLongerObtainable = true;
    end
    
    if data.classMask == 0 and CombineIntoSpecial(data.setID) then
            --updating some info for wendigo woolies
          if data.setID == 1903 then
            data.label = "Blizzcon 2019";
            data.noLongerObtainable = true;
            data.expansionID = -1;
          end
          
          if CombineIntoSpecial(data.setID) then
            data.note = data.label;
            data.label = "Special";
            data.expansionID = -1;
          end
          
          if UseSet(data) then            
            if data.label == "Special" then
              data.expansionID = -1;
              if firstSpecialSet == nil then
                firstSpecialSet = data.setID;
                BaseSets[data.setID] = data;
                table.insert(BaseList,data);
              else
                data.baseSetID = firstSpecialSet;
                AddSetToHash(data, firstSpecialSet);
                if data.favorite then
                  local baseSet = GetSetByID(firstSpecialSet);
                  baseSet.favoriteSetID = data.setID;
                end
              end
            else
              BaseSets[data.setID] = data;
              table.insert(BaseList,data);
            end
          end
    elseif UseSet(data) then
      BaseSetsPvPFlag[data.setID] = pvpDescriptions[data.description] or false;
      
      
      --For Legion Class Hall Variants Dropdown
      if (data.description == nil) then
        if ClassNameMask[data.classMask] ~= nil then
          data.description = ClassNameMask[data.classMask];
        else
          data.description = data.name;
        end
      end
      
      
      if ClassNameMask[data.classMask] ~= nil then
        data.description = ColorStringByClass(data.description,data.classMask);
      end
      
    
      --add to either base or var sets
      if (data.baseSetID == nil) then
        local combineWithOtherBaseSet = false;
        local otherBaseID;
        for _, baseSet in pairs(BaseSets) do
          if (data.label == baseSet.label) then
            combineWithOtherBaseSet = true;
            otherBaseID = baseSet.setID;
            break;
          end
        end
        
        if not combineWithOtherBaseSet then --This is the first set, defaulting to base set.
          BaseSets[data.setID] = data;
          table.insert(BaseList,data);
        else
          if (data.classMask == ClassToMask[ClassIndex]) then --Making this the new base set.
            local otherBase = BaseSets[otherBaseID];
            otherBase.baseSetID = data.setID;
            
            if data.favorite then
              favoritesToSet[otherBaseID] = data.setID;
            end
            if otherBase.favoriteSetID then
              data.favoriteSetID = otherBase.favoriteSetID;
            end
            AddSetToHash(otherBase, data.setID);
            
            local updateVarSets = SetsFrame.GetVariantSets(otherBase.setID);
            for id,set in pairs(updateVarSets) do
              RemoveSetFromHash(set);
              set.baseSetID = data.setID;
              AddSetToHash(set, data.setID);
            end
            
            for j = #BaseList, 0, -1 do
              if (BaseList[j] == otherBase) then
                table.remove(BaseList, j);
                break;
              end
            end
            
            table.insert(BaseList, data);
            BaseSets[otherBase.setID] = nil;
            BaseSets[data.setID] = data;
          else --Adding this set into an existing base set.
            data.baseSetID = otherBaseID;
            if data.favorite then
              favoritesToSet[otherBaseID] = data.setID;
            end
            
            AddSetToHash(data, otherBaseID);
            
            local updateVarSets = SetsFrame.GetVariantSets(data.setID);
            for id,set in pairs(updateVarSets) do
              RemoveSetFromHash(set);
              set.baseSetID = otherBaseID;
              AddSetToHash(set, otherBaseID);
            end
          end
        end
      else
      
        local baseID = data.baseSetID;
        
        if VariantSetsIDs[baseID] then
          baseID = VariantSets[VariantSetsIDs[baseID]].baseSetID;
          data.baseSetID = baseID;
        end
        
        if ( data.favorite ) then
          favoritesToSet[baseID] = data.setID;
        end
        
        AddSetToHash(data, baseID);
      end
    end
  end
  
  for baseFav,varFav in pairs(favoritesToSet) do
    local baseSet = GetSetByID(baseFav);
    if baseSet.baseSetID then
      baseSet = GetSetByID(baseSet.baseSetID);
    end
    baseSet.favoriteSetID = varFav;
    baseSet.favorite = true;
    for i=1,#BaseList do
      if BaseList[i].setID == baseSet.setID then
        BaseList[i] = baseSet;
        break;
      end
    end
  end
  
  for _,callback in pairs(ExpandedCallbacks) do
    callback();
  end
  
  SetsFrame.SortSets(BaseList, false);
  alreadyFilled = true;
end

local function AddSetToTables(data)
  if data == nil or data.setID == nil or not UseSet(data) then return; end --in case an empty set for some reason tries to get added.
  
  if not UseSet(data) then return; end
  
  data.favorite = IsFavorite(data.setID);

  local combineWithOtherBaseSet = false;
  local otherBaseID = 0;
  
  if data.favorite then
    data.favoriteSetID = data.setID;
  end
  
  if data.description == "" or data.description == nil then data.description = data.name; end
  
  if ClassNameMask[data.classMask] ~= nil then
    data.description = ColorStringByClass(data.description,data.classMask);
  end
  
  for _, baseSet in pairs(BaseSets) do
    if (data.label ~= nil and baseSet.label ~= nil and data.label == baseSet.label) then
      combineWithOtherBaseSet = true;
      otherBaseID = baseSet.setID;
      if data.favorite then
        baseSet.favoriteSetID = data.setID;
        baseSet.favorite = true;
      end
      break;
    end
  end
  
  if not combineWithOtherBaseSet then
    data.baseSetID = data.setID;
    BaseSets[data.setID] = data;
    table.insert(BaseList,data);
  else
    data.baseSetID = otherBaseID;
    AddSetToHash(data, otherBaseID);
  end
end

--Creates the buttons shown in the list on the left side of the sets window.
local function SetButtonData(button, set)
  local setInfo = GetBaseSetData(set.setID);
  
  button.setID = set.setID;
  button:Show();
  
  --Sets the name for the button and its color based on completion.
  button.Name:SetText(set.name);
  local color;
  if setInfo.completed then
    color = NORMAL_FONT_COLOR;
  elseif setInfo.topCollected == 0 then
    color = GRAY_FONT_COLOR;
  else 
    color = colors.IN_PROGRESS_FONT_COLOR;
  end
  button.Name:SetTextColor(color.r, color.g, color.b);
  
  --Sets the sub-name on the button.
  button.Label:SetText(set.label);
  
  button.IconCover:Show();
  button.IconCover:SetShown((set.setID == GetBaseSetID(ExS_ScrollFrame.selectedSetID)) or false);
  button.Icon:Show();
  button.Icon:SetTexture(GetIconForSet(set.setID));
  button.Icon:SetDesaturation((setInfo.topCollected == 0) and 1 or 0);
  button.Favorite:SetShown(set.favoriteSetID);
  
  --Setting if special apperance needed for newness or selectedness.
  button.New:SetShown(IsBaseSetNew(set.setID));
  button.SelectedTexture:SetShown(set.setID == GetBaseSetID(ExS_ScrollFrame.selectedSetID));
  
  --Sets the Progress Bar and Color for set completion along bottom of the button.
  if setInfo.topCollected == 0 then
    button.ProgressBar:Hide();
  else
    button.ProgressBar:Show();
    if setInfo.completed then
      button.ProgressBar:SetWidth(SET_PROGRESS_BAR_MAX_WIDTH * setInfo.numFinishedSets / setInfo.numSets);
      button.ProgressBar:SetColorTexture(color.r, color.g, color.b);
    else
      button.ProgressBar:SetWidth(SET_PROGRESS_BAR_MAX_WIDTH * setInfo.topCollected / setInfo.topTotal);
      button.ProgressBar:SetColorTexture(colors.IN_PROGRESS_FONT_COLOR.r, colors.IN_PROGRESS_FONT_COLOR.g, colors.IN_PROGRESS_FONT_COLOR.b);
    end
  end
end

-----------------------------------------------------------------------------------------------------------
  --Scroll Frame--
-----------------------------------------------------------------------------------------------------------

--Select a set. Optional additional input to make it just choose the given set and not find a default set for it.
local function ScrollFrame_SelectSet(setID, notDefault)
  if type(setID) ~= "number" then
    setID = setID.selectedSetID;
  end
  
  local baseID = GetBaseSetID(setID);
  
  --Loop through the buttons updating the current selection and new status.
  for i = 1, #ExS_ScrollFrame.buttons do 
    if ExS_ScrollFrame.buttons[i]:IsShown() and ExS_ScrollFrame.buttons[i].setID ~= nil then 
      ExS_ScrollFrame.buttons[i].SelectedTexture:SetShown(baseID == GetBaseSetID(ExS_ScrollFrame.buttons[i].setID));
      ExS_ScrollFrame.buttons[i].IconCover:SetShown(baseID == GetBaseSetID(ExS_ScrollFrame.buttons[i].setID));
      ExS_ScrollFrame.buttons[i].New:SetShown(ResetBaseSetNewStatus(ExS_ScrollFrame.buttons[i].setID));
    end
	end
  
  if (not notDefault) and (baseID == setID) then
    setID = GetDefaultSetIDForBaseSet(baseID);
  end
  
	WardrobeCollectionFrame.SetsCollectionFrame.selectedSetID = setID;
	ExS_ScrollFrame.selectedSetID = setID;
  
  DisplaySet(setID);
end

--Sets the scroll position and updates the buttons to have the data for where its scroll position is.
local function ScrollToOffset(offset, minimizeScrolling, setSet, forceEmptyList)
  if #BaseList == 0 and forceEmptyList == nil then return; end
  
	local index = 0;
	local currButton = 1;
  local offsetToSet = offset;
  local mutableOffset = offset;
  local buttonsShown = floor(ExS_ScrollFrame:GetHeight() / _ButtonHeight);
  
  local bottomOffset = #BaseList - buttonsShown + 1;
  
  local currTop = ExS_ScrollFrame.buttons[1].setID;
  local currOffset = 0;
  --Loop through the List, updating the buttons once we get to the offset.
	for _, baseSet in pairs(BaseList) do
		if currButton > #ExS_ScrollFrame.buttons then
			break;
		end
		index = index + 1;
    
    
    if minimizeScrolling and ((baseSet.setID == currTop) or (index == mutableOffset)) then
      if (mutableOffset - index) > 0 then 
        if (mutableOffset - index + 1) < buttonsShown then
          mutableOffset = index;
        else
          mutableOffset = mutableOffset - buttonsShown + 1;
        end
      end
      minimizeScrolling = false;
    end
    
    --If we need to select the set, set it if we are there.
    if setSet and index == offsetToSet then
      ScrollFrame_SelectSet(baseSet.setID);
      setSet = false;
    end
    
    --If we are past the offset (don't need to check max as currButton does that).
		if index >= mutableOffset then
      SetButtonData(ExS_ScrollFrame.buttons[currButton], baseSet);
      currButton = currButton + 1;
		end
	end
  --If there are leftover buttons, hide them.
	for i = currButton, #ExS_ScrollFrame.buttons do 
		ExS_ScrollFrame.buttons[i]:Hide();
	end
  
  local scrollMax = max((#BaseList - _ButtonsInFrame) * 46, 0);
  ExS_ScrollFrame.scrollBar:SetMinMaxValues(0, scrollMax);
	ExS_ScrollFrame.range = #BaseList * 46;
  
  --Update the scroll bar visual for our current scrolled position.
  ExS_ScrollFrame.scrollBar:SetValue(mutableOffset * 46);
end

--On scrolling update, scroll to offset
local function ExS_ScrollFrame_Update()
  local offset = ExS_ScrollFrame.scrollBar:GetValue() / 46;
  if #BaseList > 0 then
    ScrollToOffset(offset, false, false, false);
  end
end

--ScrollFrameUpdate = ScrollFrame_Update;

--WIP
local function ScrollFrame_ScrollToSet(setID)
  local baseID = GetBaseSetID(setID);
	local totalHeight = 0;
  local offset = 1;
	local scrollFrameHeight = ExS_ScrollFrame:GetHeight();
	local found = false;
	for _,set in pairs(BaseList) do
    if set.setID == baseID then
      found = true;
      break;
    end
    
		--local variantSets = GetVariantSets(id);
		--if #variantSets > 0 then
		--	for vID,_ in pairs(variantSets) do
		--		if vID == setID then
		--			found = true;
		--			break;
		--		end
		--	end
    --end
    
    --if found then
    --  break;
    --end
    
    offset = offset + 1;
		totalHeight = totalHeight + _ButtonHeight;
	end
  
  if found then
    ScrollToOffset(offset, true, true);
  else
    ScrollToOffset(0);
  end
  
  
	--if totalHeight + _ButtonHeight > ExS_ScrollFrame.scrollBar.scrollValue + scrollFrameHeight then
	--	ExS_ScrollFrame.scrollBar.scrollValue = totalHeight + _ButtonHeight - scrollFrameHeight;
	--elseif totalHeight < ExS_ScrollFrame.scrollBar.scrollValue then
	--	ExS_ScrollFrame.scrollBar.scrollValue = totalHeight;
	--end
	--ExS_ScrollFrame.scrollBar:SetValue(ExS_ScrollFrame.scrollBar.scrollValue, true);
end

local function ScrollFrame_HandleKey(pKey)
  if WardrobeCollectionFrame.SetsCollectionFrame.selectedSetID == nil then return; end
	if pKey ~= WARDROBE_DOWN_VISUAL_KEY and pKey ~= WARDROBE_UP_VISUAL_KEY then
		ExS_ScrollFrame:SetPropagateKeyboardInput(true);
		return;
	end
	
  local baseID = GetBaseSetID(WardrobeCollectionFrame.SetsCollectionFrame.selectedSetID);
  
  local offset = 0;
  local foundSet = false;
  for _,set in pairs(BaseList) do
    offset = offset + 1;
    if set.setID == baseID then
      foundSet = true;
      break;
    end
  end
      
	ExS_ScrollFrame:SetPropagateKeyboardInput(false);
  --Down was pressed, get the next set.
  if pKey == WARDROBE_DOWN_VISUAL_KEY then
    if not foundSet then
      ScrollToOffset(1, true, true);
    elseif offset < #BaseList then
      ScrollToOffset(offset + 1, true, true);
    end
  --Up was pressed, get the previous set.
  elseif pKey == WARDROBE_UP_VISUAL_KEY then
    if not foundSet then
      ScrollToOffset(1, true, true);
    elseif offset > 1 then
      ScrollToOffset(offset - 1, true, true);
    end
  end
end

local function FavoriteDropDown_Init(pSelf)
	if not SetsFrame.GetBaseSetID then
		return;
	end
  
  local baseButtonSetID = SetsFrame.GetBaseSetID(ExS_ScrollFrame.menuInitBaseSetID);
  local baseButtonSet = GetSetByID(baseButtonSetID);
  
	local baseSelectedSetID = SetsFrame.GetBaseSetID(ExS_ScrollFrame.selectedSetID);
  local setID = baseButtonSetID;
  if (baseButtonSet.favoriteSetID ~= nil) then
    setID = baseButtonSet.favoriteSetID
  elseif (baseButtonSetID == baseSelectedSetID) then
    setID = ExS_ScrollFrame.selectedSetID;
  end
  
	local variantSets = SetsFrame.GetVariantSets(baseButtonSetID, true);
  local set = GetSetByID(setID);
	local useDescription = (#variantSets > 0);
  local desc = set.description;
  if desc == nil then desc = set.name; end

	local info = UIDropDownMenu_CreateInfo();
	info.notCheckable = true;
	info.disabled = nil;
	if baseButtonSet.favoriteSetID then
		if useDescription then
			info.text = format(TRANSMOG_SETS_UNFAVORITE_WITH_DESCRIPTION, desc);
		else
			info.text = BATTLE_PET_UNFAVORITE;
		end
		info.func = function()
			C_TransmogSets.SetIsFavorite(baseButtonSet.favoriteSetID, false);
      local favSet = GetSetByID(baseButtonSet.favoriteSetID);
      local favoriteSetID = baseButtonSet.favoriteSetID;
      baseButtonSet.favoriteSetID = nil;
      baseButtonSet.favorite = false;
      favSet.favorite = false;
      favSet.favoriteSetID = nil;
      SetsFrame.SortSets(BaseList, false);
      for i=#ExS_Favorites,1,-1 do
        if ExS_Favorites[i] == favoriteSetID then
          table.remove(ExS_Favorites, i);
        end
      end
      WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
		end
	else
		local targetSetID = WardrobeCollectionFrame.SetsCollectionFrame:GetDefaultSetIDForBaseSet(ExS_ScrollFrame.menuInitBaseSetID);
		if useDescription then
			info.text = format(TRANSMOG_SETS_FAVORITE_WITH_DESCRIPTION, desc);
		else
			info.text = BATTLE_PET_FAVORITE;
		end
		info.func = function()
      if setID < ExpandedID then
        C_TransmogSets.SetIsFavorite(setID, true);
      end
      baseButtonSet.favoriteSetID = setID;
      baseButtonSet.favorite = true;
      table.insert(ExS_Favorites, setID);
      SetsFrame.SortSets(BaseList, false);
      WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
		end
	end
	UIDropDownMenu_AddButton(info);
	-- Cancel
	info = UIDropDownMenu_CreateInfo();
	info.notCheckable = true;
	info.text = CANCEL;
	UIDropDownMenu_AddButton(info);
end

local function CreateScrollbar(frame)
	WardrobeCollectionFrameScrollFrame:Hide();
		
	_ButtonHeight = WardrobeCollectionFrameScrollFrame.buttons[1]:GetHeight();
	
	ExS_ScrollFrame = CreateFrame("ScrollFrame", "SetCollectionUngroupScrollFrame", WardrobeCollectionFrame.SetsCollectionFrame, "HybridScrollFrameTemplate");
	ExS_ScrollFrame:SetAllPoints(WardrobeCollectionFrameScrollFrame);
	
	ExS_ScrollFrame.scrollBar = CreateFrame("Slider", "SetCollectionUngroupScrollFrameScrollBar", ExS_ScrollFrame, "HybridScrollBarTrimTemplate");
	ExS_ScrollFrame.scrollBar:SetAllPoints(WardrobeCollectionFrameScrollFrame.scrollBar);
	ExS_ScrollFrame.scrollBar:SetScript("OnValueChanged", function(pSelf, pValue) 
		pSelf.scrollValue = pValue;
		HybridScrollFrame_OnValueChanged(pSelf, pValue);
		ExS_ScrollFrame_Update();
	end);
	ExS_ScrollFrame.scrollBar.trackBG:Show();
	ExS_ScrollFrame.scrollBar.trackBG:SetVertexColor(0, 0, 0, 0.75);
	ExS_ScrollFrame.scrollBar.scrollValue = 0;
  
	HybridScrollFrame_CreateButtons(ExS_ScrollFrame, "WardrobeSetsScrollFrameButtonTemplate", 44, 0);
  
	for _, button in pairs(ExS_ScrollFrame.buttons) do
		button.ProgressBar:SetTexture(1, 1, 1);
		button:RegisterForClicks("AnyUp", "AnyDown");
		button:SetScript("OnMouseUp", function(pSelf, pButton, pDown)
			if pButton == "LeftButton" then
				CloseDropDownMenus();
				ScrollFrame_SelectSet(pSelf.setID);
			elseif pButton == "RightButton" then
				ExS_ScrollFrame.menuInitBaseSetID = button.setID;
				ToggleDropDownMenu(1, nil, _FavoriteDropDown, pSelf, 0, 0);
			end
		end)
	end
  
  ExS_ScrollFrame.scrollBar:SetObeyStepOnDrag(true);
  
  _ButtonsInFrame = ExS_ScrollFrame:GetHeight() / _ButtonHeight;
	
	_FavoriteDropDown = CreateFrame("Frame", "SetCollectionUngroupFavoriteDropDown", ExS_ScrollFrame, "UIDropDownMenuTemplate");
	UIDropDownMenu_Initialize(_FavoriteDropDown, FavoriteDropDown_Init, "MENU");

	ExS_ScrollFrame:SetScript("OnKeyDown", function(pSelf, pKey)
		ScrollFrame_HandleKey(pKey);
	end);
end

----
-- FILTER DropDown
----
function ExtendedWardrobeFilterDropDown_OnLoad(self)
  UIDropDownMenu_Initialize(self, ExtendedWardrobeFilterDropDown_Initialize, "MENU");
end
 
function ExtendedWardrobeFilterDropDown_Initialize(self, level, menu)
  if ( not WardrobeCollectionFrame.activeFrame ) then
    return;
  end
 
  if ( WardrobeCollectionFrame.activeFrame.searchType == LE_TRANSMOG_SEARCH_TYPE_ITEMS ) then
    WardrobeFilterDropDown_InitializeItems(self, level);
  elseif ( WardrobeCollectionFrame.activeFrame.searchType == LE_TRANSMOG_SEARCH_TYPE_BASE_SETS ) then
    ExtendedWardrobeFilterDropDown_InitializeBaseSets(self, level, menu);
  end
end
 
function ExtendedWardrobeFilterDropDown_InitializeBaseSets(self, level, menuList)
  local info = UIDropDownMenu_CreateInfo();
  info.isNotRadio = true;
 
  if level == 1 then
    info.keepShownOnClick = true;
    info.text = COLLECTED;
    info.func = function(_, _, _, value)
            C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED, value);
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_COLLECTED);
    UIDropDownMenu_AddButton(info, level);
  
    info.text = NOT_COLLECTED;
    info.func = function(_, _, _, value)
            C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED, value);
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_UNCOLLECTED);
    UIDropDownMenu_AddButton(info, level);
  
    UIDropDownMenu_AddSeparator(level);
  
    info.text = TRANSMOG_SET_PVE;
    info.func = function(_, _, _, value)
            C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE, value);
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVE);
    UIDropDownMenu_AddButton(info, level);
  
    info.text = TRANSMOG_SET_PVP;
    info.func = function(_, _, _, value)
            C_TransmogSets.SetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP, value);
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = C_TransmogSets.GetBaseSetsFilter(LE_TRANSMOG_SET_FILTER_PVP);
    UIDropDownMenu_AddButton(info, level);
    
    UIDropDownMenu_AddSeparator(level);
    
    ----
    --  Settings
    ----
    
    --Show/Hide other faction sets
    info.text = factionNames.opposingFaction;
    info.func = function(_, _, _, value)
            if (ExS_Settings.displayOtherFaction == true) then
              ExS_Settings.displayOtherFaction = false;
            else
              ExS_Settings.displayOtherFaction = true;
            end
            
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType);
          end
    info.checked = ExS_Settings.displayOtherFaction;
    UIDropDownMenu_AddButton(info, level);
    
    --Show/Hide other class sets for player's armor weight
    info.text = "Show Only My Class's Sets";
    info.func = function(_, _, _, value)
            if (ExS_Settings.displayOnlyMyClass == true) then
              ExS_Settings.displayOnlyMyClass = false;
            else
              ExS_Settings.displayOnlyMyClass = true;
            end
            
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = ExS_Settings.displayOnlyMyClass;
    UIDropDownMenu_AddButton(info, level);
    
    --Show/Hide CharCollectionIcons
    info.text = "Show Character Collection Icons";
    info.tooltipText = "Shows a Red X above items that are not collected and cannot be collected by the current character's class. Shows a Red O above items that are collected but cannot be used by the current character's class. Shows an Orange O above items that have a class-specific version collected that cannot be transmogged by the current character's class, but has a non-class-specific version that can be collected.";
    info.tooltipOnButton = true;
    info.func = function(_, _, _, value)
            if (ExS_Settings.showCharCollectionIcons == true) then
              ExS_Settings.showCharCollectionIcons = false;
            else
              ExS_Settings.showCharCollectionIcons = true;
            end
            
            for itemFrame in WardrobeCollectionFrame.SetsCollectionFrame.DetailsFrame.itemFramesPool:EnumerateActive() do
              SetsFrame.HandleItemFrames(itemFrame, false);
            end
          end
    info.checked = ExS_Settings.showCharCollectionIcons;
    UIDropDownMenu_AddButton(info, level);
    
    info.tooltipText = "";
    info.tooltipOnButton = false;
    
    --Show/Hide no longer obtainable sets
    info.text = "Hide No Longer Obtainable Sets";
    info.func = function(_, _, _, value)
            if (ExS_Settings.hideNoLongerObtainable == true) then
              ExS_Settings.hideNoLongerObtainable = false;
            else
              ExS_Settings.hideNoLongerObtainable = true;
            end
            
            local setType;
            for i = 1, 4 do
              if (ArmorTypeRadioIsChecked[i]) then
                setType = i;
                break;
              end
            end
            InitializeSets(setType, true);
          end
    info.checked = ExS_Settings.hideNoLongerObtainable;
    UIDropDownMenu_AddButton(info, level);
    
    UIDropDownMenu_AddSeparator(level);
    
    --
    -- Expansion Select opener
    --
    
    info.text = EXPANSION_FILTER_TEXT;
    info.notCheckable = true;
    info.func = nil;
    info.hasArrow = true;
    info.menuList = "ExpansionList";
    UIDropDownMenu_AddButton(info, level, info.menuList);
    
    info.notCheckable = false;
    info.hasArrow = false;
    info.menuList = nil;
    
    UIDropDownMenu_AddSeparator(level);
    
    --
    -- Armor Type Select
    --
    
    info.keepShownOnClick = false;
    info.isNotRadio = false;
  
    local _,_,armortype = GetItemInfoInstant(165459);
    info.text = armortype;
    info.func = function(_, _, _, value)
            InitializeSets(4, false);
          end
    info.checked = ArmorTypeRadioIsChecked[4];
    UIDropDownMenu_AddButton(info, level);
    
    local _,_,armortype = GetItemInfoInstant(166566);
    info.text = armortype;
    info.func = function(_, _, _, value)
            InitializeSets(3, false);
          end
    info.checked = ArmorTypeRadioIsChecked[3];
    UIDropDownMenu_AddButton(info, level);
    
    local _,_,armortype = GetItemInfoInstant(165072);
    info.text = armortype;
    info.func = function(_, _, _, value)
            InitializeSets(2, false);
          end
    info.checked = ArmorTypeRadioIsChecked[2];
    UIDropDownMenu_AddButton(info, level);
    
    local _,_,armortype = GetItemInfoInstant(165435);
    info.text = armortype;
    info.func = function(_, _, _, value)
            InitializeSets(1, false);
          end
    info.checked = ArmorTypeRadioIsChecked[1];
    UIDropDownMenu_AddButton(info, level);
    
    
    ---- Race Select
    --
    --UIDropDownMenu_AddSeparator(level);
    --info.text = RESET_TO_DEFAULT;
    --info.func = function()
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:SetCustomRace(UnitRace("player"), defaultSex);
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:Undress();
    --              WardrobeTransmogFrame_EvaluateModel(true, true);
    --              DisplaySet(ExS_ScrollFrame.selectedSetID);
    --            end
    --info.notCheckable = true;
    --UIDropDownMenu_AddButton(info, level);
    --
    --info.text = RACE;
    --info.func = nil;
    --info.hasArrow = true;
    --info.menuList = "RaceList";
    --UIDropDownMenu_AddButton(info, level, info.menuList);
    --
    --info.text = MALE;
    --info.func = function()
    --              displayBools.displayFemale = 0;
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:SetCustomRace(currentRaceID, displayBools.displayFemale);
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:UpdatePanAndZoomModelType();
    --              DisplaySet(ExS_ScrollFrame.selectedSetID);
    --            end
    --info.notCheckable = false;
    --info.hasArrow = false;
    --info.menuList = nil;
    --info.checked = displayBools.displayFemale == 0;
    --UIDropDownMenu_AddButton(info, level);
    --
    --info.text = FEMALE;
    --info.func = function()
    --              displayBools.displayFemale = 1;
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:SetCustomRace(currentRaceID, displayBools.displayFemale);
    --              WardrobeCollectionFrame.SetsCollectionFrame.Model:UpdatePanAndZoomModelType();
    --              DisplaySet(ExS_ScrollFrame.selectedSetID);
    --            end
    --info.checked = displayBools.displayFemale == 1;
    --UIDropDownMenu_AddButton(info, level);
  elseif (menuList == "RaceList") then
    info.isNotRadio = false;
    info.keepShownOnClick = false;
    
    local playerRace = UnitRace("player");
    for _,race in pairs(raceList) do
      if playerRace == race.raceName then
        info.text = ColorString(race.raceName.." ("..DEFAULT..")",0.2,0.8,0.4);
      else
        info.text = race.raceName;
        --info.text = race.raceName.."   (id = "..race.raceID..")";
      end
      info.func = function()
                    UpdateBaseListHeritageArmors(currentRaceID, race.raceID);
                    currentRaceID = race.raceID;
                    WardrobeCollectionFrame.SetsCollectionFrame.Model:SetCustomRace(currentRaceID, displayBools.displayFemale);
                    WardrobeCollectionFrame.SetsCollectionFrame.Model:UpdatePanAndZoomModelType();
                    WardrobeCollectionFrame.SetsCollectionFrame.Model:Undress();
                    WardrobeTransmogFrame_EvaluateModel(true, true);
                    WardrobeCollectionFrame.SetsCollectionFrame.Model:OnUpdate();
                    if heritageSets[ExS_ScrollFrame.selectedSetID] ~= nil then
                      ExS_ScrollFrame.selectedSetID = BaseList[1].setID;
                    end
                    DisplaySet(ExS_ScrollFrame.selectedSetID);
                    ScrollFrame_ScrollToSet(ExS_ScrollFrame.selectedSetID);
                  end
      info.checked = race.raceID == currentRaceID;
      info.menuList = menu;
      UIDropDownMenu_AddButton(info, level);
    end
  elseif (menuList == "ExpansionList") then
    info.isNotRadio = false;
    info.keepShownOnClick = true;
    info.menuList = nil;
    
    for i = 1,ExpansionCount do
      info.text = _G["EXPANSION_NAME"..(i-1)];
      info.func = function()
                    ExS_Settings.expansionToggles[i] = not ExS_Settings.expansionToggles[i];
                    
                    local setType;
                    for i = 1, 4 do
                      if (ArmorTypeRadioIsChecked[i]) then
                        setType = i;
                        break;
                      end
                    end
                    InitializeSets(setType, true);
                  end
      info.checked = ExS_Settings.expansionToggles[i];
      UIDropDownMenu_AddButton(info, level);
    end
  end
end

function AppearanceTooltipOnEnter(self)
	self:GetParent():GetParent():SetAppearanceTooltip(self)
	self:SetScript("OnUpdate",
		function()
			if IsModifiedClick("DRESSUP") then
				ShowInspectCursor();
			else
				ResetCursor();
			end
		end
	);
	if ( self.New:IsShown() ) then
		local transmogSlot = C_Transmog.GetSlotForInventoryType(self.invType);
		C_TransmogSets.ClearSetNewSourcesForSlot(self.setID, transmogSlot);
    
    local visID = C_TransmogCollection.GetSourceInfo(self.sourceID).visualID;
    for i=0,#SetsFrame.NewVisualIDs do
      if SetsFrame.NewVisualIDs[i] == visID then
        table.remove(SetsFrame.NewVisualIDs, i);
        break;
      end
    end
    
		local baseSetID = GetBaseSetID(self.setID);
		ResetBaseSetNewStatus(baseSetID);
    
    HandleItemFrames(self, true);
		WardrobeCollectionFrame.SetsCollectionFrame:Refresh();
	end
end

--Handles showing the tooltips for items in the SetSources row.
local function RefreshAppearanceTooltip()
  local self = WardrobeCollectionFrame.SetsCollectionFrame;
	if ( not self.tooltipTransmogSlot ) then
		return;
	end
  
	local sources = GetSetSourcesForSlot(WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID(), WardrobeCollectionFrame.SetsCollectionFrame.tooltipTransmogSlot);
  
	if ( #sources == 0 ) then
		-- can happen if a slot only has HiddenUntilCollected sources
		local sourceInfo = C_TransmogCollection.GetSourceInfo(self.tooltipPrimarySourceID);
		tinsert(sources, sourceInfo);
	end
	WardrobeCollectionFrame_SortSources(sources, sources[1].visualID, self.tooltipPrimarySourceID);
	WardrobeCollectionFrame_SetAppearanceTooltip(self, sources, self.tooltipPrimarySourceID);
end

--Handles Mouse click (chat link with left click, preview with right) in the SetSources row.
local function ExS_SetSources_OnMouseDown()
	if ( IsModifiedClick("CHATLINK") ) then
    local sources = GetSetSourcesForSlot(WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID(), WardrobeCollectionFrame.SetsCollectionFrame.tooltipTransmogSlot);
		if ( #sources == 0 ) then
			-- can happen if a slot only has HiddenUntilCollected sources
      local sourceInfo = C_TransmogCollection.GetSourceInfo(WardrobeCollectionFrame.SetsCollectionFrame.tooltipPrimarySourceID);
			tinsert(sources, sourceInfo);
		end
		WardrobeCollectionFrame_SortSources(sources, sources[1].visualID, WardrobeCollectionFrame.SetsCollectionFrame.tooltipPrimarySourceID);
		if ( WardrobeCollectionFrame.tooltipSourceIndex ) then
			local index = WardrobeUtils_GetValidIndexForNumSources(WardrobeCollectionFrame.tooltipSourceIndex, #sources);
			local link = select(6, C_TransmogCollection.GetAppearanceSourceInfo(sources[index].sourceID));
			if ( link ) then
				HandleModifiedItemClick(link);
			end
		end
	elseif ( IsModifiedClick("DRESSUP") ) then
    local sources = GetSetSourcesForSlot(WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID(), WardrobeCollectionFrame.SetsCollectionFrame.tooltipTransmogSlot);
		if ( #sources == 0 ) then
			-- can happen if a slot only has HiddenUntilCollected sources
      local sourceInfo = C_TransmogCollection.GetSourceInfo(WardrobeCollectionFrame.SetsCollectionFrame.tooltipPrimarySourceID);
			tinsert(sources, sourceInfo);
		end
		DressUpVisual(sources[1].sourceID);
  else
    local sources = GetSetSourcesForSlot(WardrobeCollectionFrame.SetsCollectionFrame:GetSelectedSetID(), WardrobeCollectionFrame.SetsCollectionFrame.tooltipTransmogSlot);
		if ( #sources == 0 ) then
			-- can happen if a slot only has HiddenUntilCollected sources
      local sourceInfo = C_TransmogCollection.GetSourceInfo(WardrobeCollectionFrame.SetsCollectionFrame.tooltipPrimarySourceID);
			tinsert(sources, sourceInfo);
		end
	end
end


local addonsLoaded = { false, false, false };

local frame = CreateFrame("frame"); 
frame:RegisterEvent("ADDON_LOADED");
frame:SetScript("OnEvent", function(pSelf, pEvent, pUnit)
  if pEvent == "ADDON_LOADED" then 
    if pUnit == "ExtendedSets" then
      addonsLoaded[1] = true;
      if (not addonsLoaded[2] and IsAddOnLoaded("Blizzard_Collections")) then
        addonsLoaded[2] = true;
      end
    elseif pUnit == "Blizzard_Collections" then
      addonsLoaded[2] = true;
    end
  end
  
  if not addonsLoaded[3] and addonsLoaded[1] and addonsLoaded[2] then
    addonsLoaded[3] = true;
    
    if (ExS_Settings == nil) then
      ExS_Settings = {};
    end
    if (ExS_Settings.displayOtherFaction == nil) then
      ExS_Settings.displayOtherFaction = false;
    end
    if (ExS_Settings.displayOnlyMyClass == nil) then
      ExS_Settings.displayOnlyMyClass = false;
    end
    if (ExS_Settings.showCharCollectionIcons == nil) then
      ExS_Settings.showCharCollectionIcons = true;
    end
    if (ExS_Settings.expansionToggles == nil) then
      ExS_Settings.expansionToggles = {true, true, true, true, true, true, true, true, true};
    end
    if (ExS_Settings.hideNoLongerObtainable == nil) then
      ExS_Settings.hideNoLongerObtainable = false;
    end
    if (ExS_Favorites == nil) then
      ExS_Favorites = {};
    end
  
		WardrobeCollectionFrameScrollFrame:Hide();
    
    SetsFrame = CreateFromMixins(WardrobeSetsDataProviderMixin);
    DetailsItems = CreateFromMixins(WardrobeSetsDetailsItemMixin);
    
    DetailsItems.OnEnter = AppearanceTooltipOnEnter;
    
		CreateScrollbar(frame);
    
		SetsFrame.GetBaseSets = GetBaseSets;
		SetsFrame.GetVariantSets = GetVariantSets;
    SetsFrame.FillSetMaps = FillSetMaps;
		--SetsFrame.DetermineFavorites = DetermineFavorites;
		SetsFrame.IsBaseSetNew = IsBaseSetNew;
		SetsFrame.GetBaseSetData = GetBaseSetData;
		SetsFrame.GetSetSourceData = GetSetSourceData;
		SetsFrame.GetIconForSet = GetIconForSet;
		SetsFrame.GetSetSourceCounts = GetSetSourceCounts;
		SetsFrame.ResetBaseSetNewStatus = ResetBaseSetNewStatus;
		SetsFrame.GetSortedSetSources = GetSortedSetSources;
		SetsFrame.GetBaseSetID = GetBaseSetID;
		SetsFrame.FavoriteDropDown_Init = FavoriteDropDown_Init;
    SetsFrame.SortSets = SortSets;
    SetsFrame.SelectSet = ScrollFrame_SelectSet;
    SetsFrame.ScrollToSet = ScrollFrame_ScrollToSet;
    SetsFrame.ScrollToOffset = ScrollToOffset;
    SetsFrame.InitializeSets = InitializeSets;
    SetsFrame.AddSetToTables = AddSetToTables;
    SetsFrame.ExpandedID = ExpandedID;
    SetsFrame.ExpandedIDOffset = ExpandedIDOffset;
    SetsFrame.ExpandedCallbacks = ExpandedCallbacks;
    SetsFrame.GetSetSources = GetSetSources;
    SetsFrame.ExS_SetSources_OnMouseDown = ExS_SetSources_OnMouseDown;
    SetsFrame.HandleItemFrames = HandleItemFrames;
    SetsFrame.DisplaySet = DisplaySet;
    SetsFrame.AppearanceTooltipOnEnter = AppearanceTooltipOnEnter;
    SetsFrame.UseSet = UseSet;
    SetsFrame.ExS_ScrollFrame_Update = ExS_ScrollFrame_Update;
    
    SetsFrame.NewVisualIDs = {};
    
		------------------------------------------------------------------------
		WardrobeCollectionFrame.SetsCollectionFrame.OnShow = OnShow;
    WardrobeCollectionFrame.SetsCollectionFrame:SetScript("OnShow", OnShow);
		WardrobeCollectionFrame.SetsCollectionFrame.OnHide = OnHide;
    WardrobeCollectionFrame.SetsCollectionFrame:SetScript("OnHide", OnHide);
		WardrobeCollectionFrame.SetsCollectionFrame.OnEvent = OnEvent;
    frame:SetScript("OnEvent", OnEvent);
    WardrobeCollectionFrame.SetsCollectionFrame:SetScript("OnEvent", OnEvent);
		WardrobeCollectionFrame.SetsCollectionFrame.DisplaySet = DisplaySet;
		WardrobeCollectionFrame.SetsCollectionFrame.OnSearchUpdate = OnSearchUpdate;
		WardrobeCollectionFrame.SetsCollectionFrame.SelectSet = ScrollFrame_SelectSet;
		WardrobeCollectionFrame.SetsCollectionFrame.GetDefaultSetIDForBaseSet = GetDefaultSetIDForBaseSet;
		WardrobeCollectionFrame.SetsCollectionFrame.OpenVariantSetsDropDown = OpenVariantSetsDropDown;
		WardrobeCollectionFrame.SetsCollectionFrame.GetBaseSets = GetBaseSets;
		WardrobeCollectionFrame.SetsCollectionFrame.UpdateProgressBar = UpdateProgressBar;
    WardrobeCollectionFrame.SetsCollectionFrame.ScrollToSet = ScrollFrame_ScrollToSet;
		WardrobeCollectionFrame.SetsCollectionFrame.RefreshAppearanceTooltip = RefreshAppearanceTooltip;
    WardrobeCollectionFrame.SetsCollectionFrame.GetBaseSetData = GetBaseSetData;
    WardrobeCollectionFrame.SetsCollectionFrame.SetsDataProvider = SetsFrame;
    
    WardrobeCollectionFrame.SetsCollectionFrame:RegisterEvent("TRANSMOG_COLLECTION_SOURCE_ADDED");
    WardrobeCollectionFrame.SetsCollectionFrame:RegisterEvent("TRANSMOG_COLLECTION_SOURCE_REMOVED");
    
    -------------------------------------------------------------------------
    WardrobeCollectionFrame.SetsCollectionFrame.Model:SetUnit("player")
    --WardrobeCollectionFrame.SetsCollectionFrame.Model.UpdatePanAndZoomModelType = ExS_UpdatePanAndZoomModelType;
    --WardrobeCollectionFrame.SetsCollectionFrame.Model.GetPanAndZoomLimits = ExS_GetPanAndZoomLimits;
    --WardrobeCollectionFrame.SetsCollectionFrame.Model:SetScript("OnModelLoaded", ExS_OnModelLoaded);
    --WardrobeCollectionFrame.SetsCollectionFrame.Model:SetScript("OnMouseWheel", ExS_OnMouseWheel);
		--ModelFrame = CreateFromMixins(WardrobeSetsDetailsModelMixin);
    --ModelFrame.UpdatePanAndZoomModelType = ExS_UpdatePanAndZoomModelType;
    --ModelFrame.GetPanAndZoomLimits = ExS_GetPanAndZoomLimits;

    UIDropDownMenu_Initialize(WardrobeCollectionFrame.FilterDropDown, ExtendedWardrobeFilterDropDown_Initialize, "MENU");

    app.SetsFrame = SetsFrame;

    func_ScrollToOffset = ScrollToOffset;

	--elseif ExS_ScrollFrame then 
	--	if pEvent == "TRANSMOG_SETS_UPDATE_FAVORITE" then
	--		WardrobeCollectionFrameScrollFrame:OnEvent(pEvent);
	--	end
	--	ScrollFrame_Update();
	end
end)
